<?php
/**
 * Description of Ajax
 *
 * @author carlos
 */
class AppointmentAjax extends AppointmentRepository {
    
    public function getResponse($request, $options) {
        return $this->$request($options);
    }
    
    public function _getTranslation($text){
        $translator = new Translator();
        return $translator->_getTranslation($text);
    }
    
    public function getTranslation($options){
        $msj = $options['msj'];
        
        return array(
            'response'=>true,
            'translation'=>$this->_getTranslation($msj)
                );
    }
    
    public function getAvailableHours($options){       
        $id = null;
        if(isset($options['id'])){$id = $options['id'];}
        
        $tools = new Tools();   
        $date = $tools->setFormatDateToDB($options['date']);
       
        $appointmentOptionsRepo = new AppointmentOptionsRepository();
        $hoursOptions = $appointmentOptionsRepo->getHoursOptionsByDay(date('N',strtotime($date)));

        if(is_null($hoursOptions)){    
            $availabeHours = "<option value=''>No hay citas disponibles para dia seleccionado.</option>";
            return array(
                'response'=>true,
                'availableHours'=>$availabeHours);            
        }   
        
        /*Obtener citas ya programadas para dia seleccionado*/
        $appointments = $this->getAppointmentsByDate($options['date'],$id);    
        if($appointments){           
            /*Eliminar horas que ya estan programadas para cita*/
            foreach($appointments as $key => $hour){
                $hour = substr($hour['appointment_hour'], 0, 5);
                if(in_array($hour, $hoursOptions)){unset($hoursOptions[$hour]);}
            }
        }      
       
        $availabeHours = "<option value=''>No hay citas disponibles para el dia seleccionado.</option>";
        if(count($hoursOptions) > 0){
             $availabeHours = "";
            foreach($hoursOptions as $key => $hour){
                $availabeHours .= "<option value='$hour'>$hour</option>";
            }
        }
        
        return array(
                'response'=>true,
                'availableHours'=>$availabeHours);   
        
    }
    
    public function mailingAppointment($options){
         $empresa = new EmpresaEntity();
         $empresa->setOptions($empresa->getById(1));
         
         $appointment = $this->getById($options['appointment_id']);
         
         $emailer = new Emailer();
         $rs = $emailer->sendEmail(array(
             'to'=>$appointment['customer_email'],
             'subject'=>$this->_getTranslation('Su Cita #').' '.$appointment['appointment_num'].' '.$this->_getTranslation('de')." ".$empresa->getNombre(),
             'message'=>  file_get_contents(ROOT_HOST."/View/Tickets/email_templates/appointment.php?appointment_id={$options['appointment_id']}"),
             'msg-success'=>'Cita enviada correctamente.'
         ));
             
        if(isset($options['from_ajax'])){
            $message = $this->flashmessenger->getMessageString();
        }else{
            $message = $this->flashmessenger->getMessageString(null);
        }
             
         return array(
             'response'=>true,
             'message'=>$message
         );
     }
}