<?php
/**
 * Description of Ajax
 *
 * @author carlos
 */
class NotificationAjax extends NotificationRepository {
    
    public function getResponse($request, $options) {
        return $this->$request($options);
    }
    
    public function _getTranslation($text){
        $translator = new Translator();
        return $translator->_getTranslation($text);
    }
    
    public function getTranslation($options){
        $msj = $options['msj'];
        
        return array(
            'response'=>true,
            'translation'=>$this->_getTranslation($msj)
                );
    }
    
    public function resendNotification($options){    
        $rs = $this->sendNotification($options['notification_id']);
        
        if($rs){
            $this->flashmessenger->addMessage(array('success'=>'Mensaje enviado correctamente'));
        }else{
            $this->flashmessenger->addMessage(array('danger'=>'Error al tratar de enviar el mensaje.'));
        }
        
        return array(
                'response'=>true,
                'message'=>$this->flashmessenger->getMessageString());   
        
    }
    
    public function loadLastNotifications($options = null){
        $this->sendScheduledNotifications();
        
        $login = new Login();
        $user_id = $login->getId();
        
        $lastNotifications = $this->getNotificationsPendingToShowOnPopUp($user_id);
        $stringNotifications = '';
        if($lastNotifications){
            foreach($lastNotifications as $notification){
                $stringNotifications .= " <div class='alert alert-warning'>
                    <a href='#' class='close' data-dismiss='alert' aria-label='close'>&times;</a>
                    <p>
                        <strong><a href='Mailbox.php?action=read&id={$notification['id']}'>{$notification['subject']}</a></strong>
                        <small><em>{$notification["message"]}</em></small>
                    </p>
                </div>";        
            }
            
            $this->setNotificationAsShowOnPopup();
            $unreadMsg = $this->getMessagesUnreadByUserId($user_id);
            if($unreadMsg){$unreadMsg = count($unreadMsg);}

            return array(
                'response'=>true,
                'messages'=>$stringNotifications,
                'unreadMessages'=>$unreadMsg
            );
        }
        
        return array(
            'response'=>null
        );        
    }
}