<?php
class SupplieReturnAjax extends SupplieReturnRepository {    
    public function __construct() {
        parent::__construct();
    }

    public function getResponse($request, $options) {
        return $this->$request($options);
    }

    public function setReturnDetails(array $options) {
        $data = array();
        foreach($options['options'] as $row){
            $data[$row['name']] = $row['value'];
        }

        $options = $data;        
        $data = array(
            'idDetailTemp'=>$options['idDetailTemp'],
            'idProduct'=>$options['idProduct'],
            'quantity'=>$options['quantity'],
            'location'=>$options['location']); 

        $this->insertDetalle($data);
        $compraDetalles = $this->getReturnDetails();
        $detalles = $this->listReturnDetalles($compraDetalles);

        $json = array(
            'response' => true,
            'returnDetails' => $detalles['listDetails'],
            'totalItems'=>number_format($detalles['totalItems'],2,'.','')
        );

        return $json;
    }
    
    public function listReturnDetalles($detalles){
        $tools = new Tools();
        $listDetalles = "";
        $cantidadItems = 0;        
        
        foreach($detalles as $detalle){
            $id = $detalle['id'];
            unset($detalle['id']); # se elimina para que no sustituya el Id del Return que se esta editando
            
            $array = json_encode($detalle);
            $cantidadItems += $detalle['quantity'];
           
            $listDetalles .= "<tr>         
                <td class='text-center'>                       
                    <a class='btn btn-sm btn-primary' onclick='setDetailReturnToEdit($array);'><i class='fa fa-pencil'></i></a>
                    <a class='btn btn-sm btn-danger' onclick='deleteReturnDetails($id);'><i class='fa fa-trash'></i></a>
                </td>
                 <td class='text-center'>".$detalle['code']."</td> 
                <td class='text-left'>".$detalle['description'].' '.$detalle['brand']."</td> 
                <td class='text-center'>".$detalle['presentation']."</td>                                    
                <td class='text-center'>".$detalle['location']."</td>  
                <td class='text-right'>".number_format($detalle['quantity'],2)."</td>         
                </tr>";
        }
        
        return array('listDetails'=>$listDetalles,
                     'totalItems'=>$cantidadItems,
            );
    }
    
    public function getListReturnDetails(){
        $returnDetalles = $this->getReturnDetails();
        $detalles = $this->listReturnDetalles($returnDetalles);
        
        $json = array(
                'response' => true,
                'returnDetails' => $detalles['listDetails'],
                'totalItems'=>number_format($detalles['totalItems'],2,'.','')
            ); 
            
            return $json;
    }

    public function deleteDetail(array $options){
        $id = $options['id'];
        $repository = new SupplieReturnDetailsTempRepository();
        
        if($repository->delete($id)){
            $response = true;
            $msj = 'Producto eliminado correctamente.';
        }else{
            $response = null;
            $msj = "No se pudo eliminar producto. Intente nuevamente.";
        }
        
        $returnDetalles = $this->getReturnDetails();
        $detalles = $this->listReturnDetalles($returnDetalles);

        $json = array(
                'response' => true,
                'returnDetails' => $detalles['listDetails'],
                'totalItems'=>number_format($detalles['totalItems'],2,'.',''),
            ); 
            return $json;
    }
    
    /*NEW */    
    public function getListSupplies($options){
        $repository = new SupplieAndServiceRepository();
        $item = $options['item'];
        
        $items = $repository->getProductsLike($item);
        
        if($items){
            $array = array();
            foreach($items as $item){
                $array[] = array(
                    'value'=>$item['id'],
                    'label'=>$item['description']." (".$item['code'].")"
                );
            }
        }
        return array(
            'response'=>true,
            'supplies'=>$array
        );   
    }
    
    public function getSupplieLocations($options){
        $repo = new InventorySupplieRepository();
        $locationsIds = $repo->getLocationForProduct($options['idProduct']);
        
        $locations = null;
        if($locationsIds){
            $repoSupplieLocation = new SupplieLocationRepository();
            $locations = $repoSupplieLocation->getListSelectSupplieLocations($locationsIds);
        }      
        
        $listLocations = "";           
        if($locations && count($locations) > 0){
            foreach($locations as $idLocation => $locationName){
                $listLocations .= "<option value='$idLocation'>$locationName</option>";
            }
        }else{
            $listLocations .= "<option value='0'>".$this->_getTranslation('Seleccionar una opcion...')."</value>"; 
        }        
        
        return array(
            'response'=>true,
            'location'=>$listLocations,
            'numLocations'=>count($locations)
        );
    }
    
    public function getDefaultDataProduct($options){
        $repo = new SupplieAndServiceRepository();
        $data = $repo->getById($options['idProduct']);
       
        $locations = array();
        if($data['location']){
            $repoSupplieLocation = new SupplieLocationRepository();
            $locations = $repoSupplieLocation->getListSelectSupplieLocations($data['location']);
        }
        
        $listLocations = "";           
        /*Si existen locaciones agregadaas para este producto se listan*/
        if($locations && count($locations) > 0){
            foreach($locations as $idLocation => $locationName){
                $listLocations .= "<option value='$idLocation'>$locationName</option>";
            }
        }else{
            /*Si no hay locaciones seleccionadas se envia por default 0*/
            $listLocations = "<option value='0'>".$this->_getTranslation('Seleccionar una opcion...')."</value>";  
        }    
        
        return array(
            'response'=>true,
            'location'=>$listLocations,
            'numLocations'=>count($locations)
        );
    }
    
    public function getSupplieByCode($options){
        $repo = new SupplieAndServiceRepository();
        $data = $repo->getByCode($options['code']);
        
        return array(
            'response'=>true,
            'idProduct'=>$data['id']
        );
    }
}