<?php  
class ReceivingPDF {
    private $pathfFileCreated = null; 
    public function __construct($idShipment,$createFile = null) {
        $receiving = new ReceivingRepository();
        $receiving->setOptions($receiving->getById($idShipment));
        $receiving->setId($idShipment);
        
        $empresa = new CompanyEntity();
        $empresa->setOptions($empresa->getById(1));        
        
        //Modifique metodo AddPage para qe ricibiera un tercer parametro, dicho parametro contiene el texto para a marca de agua.
        // para crear la marca de agua agregue las funciones Header y RotatedText en pdf.php 
        $pdf = new PDF();
        if($receiving->getStatus() == '3'){
            $pdf->AddPage('','','  Cancelada');
        }else{
            $pdf->AddPage('','');
        }

        //$pdf->Image(ROOT."/public/img/logo.png",10,10,80,0);
        //$pdf->Image(ROOT."/public/img/logo.png",170,275,30,0);
        
        $pdf->SetFont('Arial','','14');
        $pdf->SetTextColor(255);
        $pdf->SetFillColor(51,153,255);
        $pdf->SetX(0);
        $pdf->Cell(90,10, "RECIBO No: ".$receiving->getNumShipment(), '0', 0, 'R',true);   
        $pdf->Cell(15, 10, "", '', 0, 'C'); //<== margin left 
        $pdf->SetTextColor(0);
        $pdf->Cell(95, 10, $empresa->getName(), 'L', 1, 'R');          
        
        $pdf->SetFont('Arial','','9');
        $pdf->Cell(40, 6, "STATUS: ", '', 0, 'R');
        $pdf->Cell(40, 6, $receiving->getStatusName(), '', 0, 'R');              
        $pdf->Cell(15, 5, "", '', 0, 'C'); //<== margin left 
        $pdf->SetFont('Arial','','12');
        $pdf->cell(95,5,$empresa->getWebPage(),'L',1,'R');

        $pdf->SetFont('Arial','','9');
        $pdf->Cell(40, 5, 'FECHA Y HORA DE ENVIO: ', '', 0, 'R');
        $pdf->Cell(40, 5, $receiving->getShipmentDateFormated(), '', 1, 'R');  
        $pdf->Cell(40, 5, 'FECHA Y HORA DE RECIBO: ', '', 0, 'R');
        $pdf->Cell(40, 5, $receiving->getDateFormated(), '', 0, 'R');
        
        //$pdf->Cell(80, 7,'', '', 0);
        
        $pdf->Ln(1);
        $pdf->SetFont('Arial','','8');
        $pdf->SetTextColor(0);
        
        $direccion  ="\n".$empresa->getAddress();
        $direccion .= "\n".$empresa->getCity().', '.$empresa->getState().' '.$empresa->getZipCode();
        $direccion .= "\n".$empresa->getPhone();
        $pdf->Cell(190, 15, $direccion, '0', 1, 'R');
       
        $pdf->SetFont('Arial','B','8');         
        $pdf->cell(100,4,'ENVIO DESDE:','',0,'L'); 
        $pdf->cell(105,4,'ENVIO PARA:','',1,'L'); 
        
        
        $sucursal = new SucursalRepository();
        $sucursal->setOptions($sucursal->getById($receiving->getFromStore()));
        $fromStore = "\nSucursal: ".$sucursal->getNombre();
        $fromStore .= "\n".$sucursal->getDireccion();
        $fromStore .= "\n".$sucursal->getCiudad().", ".$sucursal->getEstado()." ".$sucursal->getCodigoPostal();
        $fromStore .= "\n".$sucursal->getTelefono();
        
        $sucursal->setOptions($sucursal->getById($receiving->getToStore()));
        $toStore = "\nSucursal: ".$sucursal->getNombre();
        $toStore .= "\n".$sucursal->getDireccion();
        $toStore .= "\n".$sucursal->getCiudad().", ".$sucursal->getEstado()." ".$sucursal->getCodigoPostal();
        $toStore .= "\n".$sucursal->getTelefono();
        
        $pdf->SetFont('Arial','','8'); 
        $pdf->Cell(100, 12, $fromStore, '0', 0, 'L');
        $pdf->cell(105,12,$toStore,'0',1,'L');       
       
        $pdf->Ln(5);        
        $pdf->SetFont('Arial','B','8');
        
        $pdf->Cell(80, 7, "Descripcion", 'B', 0, 'L');
        $pdf->Cell(30, 7, utf8_decode("Tamaño"), 'B', 0, 'L');
        $pdf->Cell(25, 7, "Enviado", 'B', 0, 'R'); 
        $pdf->Cell(25, 7, "Recibido", 'B', 0, 'R'); 
        $pdf->Cell(25, 7, "Diferencia", 'B', 1, 'R'); 
               
        $pdf->SetFont('Arial','','8');
        $detalles = $receiving->getReceivingDetailsSaved($idShipment,true);
        $totalEnviado = 0;
        $totalRecibido = 0;
        
        foreach($detalles as $detalle){
            $totalEnviado += $detalle['quantity'];
            $totalRecibido += $detalle['received'];
            
            $h = 5;
            $description = $detalle['description'];
            if($detalle['is_special_order'] == '1'){
                $h= 15;
                $descriptionArray = explode('|', $detalle['description']);
                $description = "Orden especial #:".$descriptionArray[0]."\nCliente: ".$descriptionArray[1]."\nFecha de entrega:".$descriptionArray[2]."\nEntregar en:".$descriptionArray[3];
            }
            
            $pdf->Cell(80, $h, utf8_decode($description), 'B', 0, 'L');
            $pdf->Cell(30, $h, utf8_decode($detalle['size']), 'B', 0, 'L');
            $pdf->Cell(25, $h, number_format($detalle['quantity']), 'B', 0, 'R');
            $pdf->Cell(25, $h, number_format($detalle['received']), 'B', 0, 'R');
            $signo = '';
            if($detalle['received'] > $detalle['quantity']){$signo = '+';}
            elseif($detalle['received'] < $detalle['quantity']){$signo = '-';}
            $pdf->Cell(25, $h, $signo.number_format($detalle['received'] - $detalle['quantity']), 'B', 1, 'R');
        }      
        
        $pdf->Cell(110, 7, "Total", 'B', 0, 'R');
        $pdf->Cell(25, 7, $totalEnviado, 'B', 0, 'R'); 
        $pdf->Cell(25, 7, $totalRecibido, 'B', 0, 'R'); 
        $signo = '';
        if($totalRecibido > $totalEnviado){$signo = '+';}
        elseif($totalRecibido < $totalEnviado){$signo = '-';}
        $pdf->Cell(25, 7, $signo.number_format($totalRecibido - $totalEnviado), 'B', 1, 'R'); 
        
                      
        $pdf->Ln(2);
        $msgArray = explode("<br />",nl2br($receiving->getShipmentComments()));
        $commentsShipment = "";
        foreach($msgArray as $line){
            $commentsShipment .= $line."\n";
        }
        
        $pdf->SetFont('Arial','B','8');
        $pdf->Cell(85, 7, "Notas envio", 'B', 1, 'L');
        $pdf->SetFont('Arial','','8');
        $pdf->Multicell(85, 5,  $receiving->getShipmentComments(), '0', 1, 'L');
        
        $msgArray = explode("<br />",nl2br($receiving->getComments()));
        $comments = "";
        foreach($msgArray as $line){
            $comments .= $line."\n";
        }
        
        $pdf->SetFont('Arial','B','8');
        $pdf->Cell(85, 7, "Notas recibo", 'B', 1, 'L');        
        $pdf->SetFont('Arial','','8');
        $pdf->Multicell(85, 5,  $receiving->getComments(), '0', 1, 'L');    
        
        /*        
        //Crear codigo
        QRcode::png('?re='.$empresa->getRFC().'&rr='.$receiving->getRFC().'&tt='.$receiving->getTotalParaCodigoQR().'&id='.$receiving->getUUID(),PATH_TEMP_DOCS."qrCode".$receiving->getSerie()."-".$receiving->getFolio().".png",'Q',3); // creates file
        $pdf->Image(PATH_TEMP_DOCS."qrCode".$receiving->getSerie()."-".$receiving->getFolio().".png",10,165,30,0);
        
        $pdf->ln(12);
       
        */
        if($createFile){
            if(!is_dir(PATH_TEMP_DOCS."requisitions/")){
                mkdir(PATH_TEMP_DOCS."requisitions/",0777,true);
            }
            $pdf->Output(PATH_TEMP_DOCS."requisitions/REQ-".$idShipment.".pdf","F");
            $this->pathfFileCreated = PATH_TEMP_DOCS."requisitions/REQ-".$idShipment.".pdf";
        }else{
            $pdf->Output();
        }
    }
    
    public function getPathFileCreated(){
        return $this->pathfFileCreated;
    }
}