<?php  
class SupplieOutPDF {
    private $pathfFileCreated = null; 
    public function __construct($idStoreOut,$createFile = null) {
        $storeOut = new SupplieOutRepository();
        $storeOut->setOptions($storeOut->getById($idStoreOut));
        $storeOut->setId($idStoreOut);
        
        $empresaRepo = new CompanyRepository();
        $empresa = $empresaRepo->getById(1);       
        
        //Modifique metodo AddPage para qe ricibiera un tercer parametro, dicho parametro contiene el texto para a marca de agua.
        // para crear la marca de agua agregue las funciones Header y RotatedText en pdf.php 
        $pdf = new PDF();
        if($storeOut->getStatus() == '2'){
            $pdf->AddPage('','','Cancelada');
        }else{
            $pdf->AddPage('','');
        }

        //$pdf->Image(ROOT."/public/img/logo.png",10,10,80,0);
        //$pdf->Image(ROOT."/public/img/logo.png",170,275,30,0);
        
        $pdf->SetFont('Arial','','14');
        $pdf->SetTextColor(255);
        $pdf->SetFillColor(51,153,255);
        $pdf->SetX(0);
        $pdf->Cell(90,10, "SALIDA # ".$storeOut->getId(), '0', 0, 'R',true);   
        $pdf->Cell(15, 10, "", '', 0, 'C'); //<== margin left 
        $pdf->SetTextColor(0);
        $pdf->Cell(95, 10, $empresa['nombre'], 'L', 1, 'R');          
        
        $pdf->Cell(95, 7,'', '', 0);
        
        $pdf->SetFont('Arial','','8');
        $pdf->SetTextColor(0);        
        $direccion  = $empresa['direccion'];
        $direccion .= "\n".$empresa['ciudad'].', '.$empresa['estado'].' '.$empresa['codigopostal'];
        $direccion .= "\n".$empresa['telefono'];
        $pdf->Cell(95, 9, $direccion, '0', 1, 'R');
       
        $pdf->SetFont('Arial','B','10');         
        $pdf->cell(95,6,'INFORMACION:','0',1,'L'); 
        
        $pdf->SetFont('Arial','','8');         
        $pdf->Cell(20, 4, "Fecha:", '0', 0, 'R');
        $pdf->Cell(75, 4, $storeOut->getFormatedDate(), '0', 1, 'L');
        
        $pdf->Cell(20, 4, "Status:", '0', 0, 'R');
        $pdf->Cell(75, 4, $storeOut->getStatusName(), '0', 1, 'L');
       
        
        $pdf->Ln(5);        
        $pdf->SetFont('Arial','B','8');
        $pdf->Cell(20, 6, "Codigo", 'B', 0, 'C');
        $pdf->Cell(45, 6, "Descripcion", 'B', 0, 'C');
        $pdf->Cell(25, 6, "Presentacion", 'B', 0, 'C');
        $pdf->Cell(25, 6, "Locacion", 'B', 0, 'C');  
        $pdf->Cell(20, 6, "Cantidad", 'B', 1, 'R');
        
        $pdf->SetFont('Arial','','8');
        $detalles = $storeOut->getSupplieOutDetailsSaved($idStoreOut);
        $cantidadItems = 0;
       
        foreach($detalles as $detalle){      
            $cantidadItems += $detalle['quantity'];         
            
            $pdf->Cell(20, 4, utf8_decode($detalle['code']), 'B', 0, 'C');
            $pdf->Cell(45, 4, utf8_decode($detalle['description']), 'B', 0, 'C');
            $pdf->Cell(25, 4, utf8_decode($detalle['presentationName']), 'B', 0, 'C');
            $pdf->Cell(25, 4, utf8_decode($detalle['locationName']), 'B', 0, 'C');
            $pdf->Cell(20, 4, number_format($detalle['quantity'],2), 'B', 1, 'R');
        }      
              
        $pdf->SetFont('Arial','B','8');
        $pdf->Cell(115, 5, 'Total productos', '0', 0, 'R');
        $pdf->SetFont('Arial','','8');
        $pdf->Cell(20, 5, number_format($cantidadItems,2), '0', 1, 'R');
        
        $pdf->ln(5);
        $pdf->SetFont('Arial','B','8');
        $pdf->Cell(85, 7, "Comentarios", 'B', 1, 'L');        
        $pdf->SetFont('Arial','','8');
        //$pdf-Cell(85, 25,  $comments1, '0', 1, 'L');  
        $pdf->MultiCell(120, 4,  $storeOut->getComments());   
        
        $pdf->Ln(20);
        $pdf->Cell(20, 7, "", '', 0, 'C');    
        $pdf->Cell(50, 7, $storeOut->getRequestedBy(), 'T', 0, 'C'); 
        $pdf->Cell(50, 7, "", '', 0, 'C');    
        $pdf->Cell(50, 7, $storeOut->getUserName(), 'T', 1, 'C');      
        
        $pdf->Cell(20, 3, "", '', 0, 'C');    
        $pdf->Cell(50, 3, 'Requerido por', '', 0, 'C'); 
        $pdf->Cell(50, 3, "", '', 0, 'C');    
        $pdf->Cell(50, 3, 'Entregado por', '', 1, 'C');    

        $pdf->Output();

        if($createFile){
            if(!is_dir(PATH_TEMP_DOCS."SupplieOut/")){
                mkdir(PATH_TEMP_DOCS."SupplieOut/",0777,true);
            }
            $pdf->Output(PATH_TEMP_DOCS."SupplieOut/SalidaInsumo-".$idStoreOut.".pdf","F");
            $this->pathfFileCreated = PATH_TEMP_DOCS."SupplieOut/SalidaInsumo-".$idStoreOut.".pdf";
        }else{
            $pdf->Output();
        }
    }
    
    public function getPathFileCreated(){
        return $this->pathfFileCreated;
    }
}