<?php
class AccountingReportListasEntity Extends AccountingReportListasRepository{
    
    public $flashmessenger = null;
    private $saveFile = null;
    private $options = array(
        'report'=>null,
        'startDate'=>null,
        'endDate'=>null,
        'vendor'=>null,
        'status'=>null,        
        'vendor_type'=>null
    );
    
    private $nombreArchivo = null;
    private $reporte = null;
    private $tempFolder = null;
    private $headerExcelReport = null;
    
    private $reportes = array(
        'accounts_payable'=>'accountsPayable',
        'accounts_payable_details'=>'accountsPayableDetails',
        'vendor_statement'=>'vendorStatement',
        'inventory_cost'=>'inventoryCost'
    );
    
    private $nombreReportes = array(
        'accounts_payable'=>'Cuentas por pagar',
        'accounts_payable_details'=>'Cuentas por pagar detalles',
        'vendor_statement'=>'Estado de cuenta proveedores',
        'inventory_cost'=>'Costo de inventario'
    );
    
    private $reportesEspeciales = array(
        'storeIn'=>'storeIn',
        'accounts_payable_details'=>'Cuentas por pagar detalles',
        'inventory_cost'=>'Costo de inventario'
    );
    
    private $reportesEspecialesPantalla = array(
        'accounts_payable'=>'accounts_payable',
    );    
    
     #Para pantala=la 'nombreReporte'=>'nombreArchivo en View/Reports/PDF'
    private $reportesEspecialesPDF = array(
        'vendor_statement'=>'Estado de cuenta de proveedores',
    );
    
    public function __construct() {
        if(!$this->flashmessenger instanceof FlashMessenger){
            $this->flashmessenger = new FlashMessenger();
        }
    }
    
    public function _getTranslation($text){
        return $this->flashmessenger->_getTranslation($text);
    }
    
    public function setOptions($data){
      foreach ($this->options as $option => $value){
          if(isset($data[$option])){
            $this->options[$option] = $data[$option];
          }
      }
      $this->createReporte();
    }
    
    public function getOptions(){
        return $this->options;
    }
    
    public function getNombreReporte(){
        return $this->options['report'];
    }
    
    public function getTituloReporte(){
        return $this->nombreReportes[$this->options['report']];
    }
    
    public function getNombreArchivo(){
        return str_replace(' ', '', $this->nombreArchivo);
    }
    
    public function setNombreArchivo(){
        if(isset($this->nombreReportes[$this->getNombreReporte()])){
            $this->nombreArchivo = $this->nombreReportes[$this->getNombreReporte()];
        }
    }
    
    public function setNombreReporteManual($nombreArchivo){
        $this->nombreArchivo = $nombreArchivo;
    }
    
    public function setHeaderExcelReportManual($headerReport){
        $this->headerExcelReport = $headerReport;
    }
    
    public function createReporte(){
        $nombreReporte = $this->reportes[$this->getNombreReporte()];
        $this->setNombreArchivo();
        $this->setReporte($this->$nombreReporte());  

        $_SESSION['optionsCurrentReport'] = array(
            'options'=>$this->getOptions()
        );
    }
    
    public function getStringToSendGET(){
        $options = $this->getOptionsCurrentReport();
        $string = "?";
        foreach($options['options'] as $key => $value){
            $string .= $key."=".$value."&";
        }
        
        $string = trim($string,"&");
        return $string;
    }
    
    public function getOptionsCurrentReport(){
        return $_SESSION['optionsCurrentReport'];
    }
    
     public function setReporte($data){
       if($data == null){ 
            $this->flashmessenger->addMessage(array('danger'=>'No se encontraron resultados.'));
            header('location: '.ROOT_HOST.'/Controller/Accounting-reports.php');
            exit;
        }
        
        $this->reporte = $data; 
    }
    
    public function getReporte(){
       return $this->reporte;
    }
    
    public function accountsPayable(){        
        return parent::getAccountsPayable($this->getOptions());
    }
    
    public function accountsPayableDetails(){        
        return parent::getAccountsPayableDetails($this->getOptions());
    }
    
    public function vendorStatement(){
        return parent::getVendorStatement($this->getOptions());
    }
    
    public function inventoryCost(){
        return parent::getInventoryCost($this->getOptions());
    }
    
    public function getReporteOnFile($formato = null){                
        $empresa = new CompanyEntity();
        $empresa = $empresa->getById(1);
        
        $startDate = $this->options['startDate'];
        $endDate = $this->options['endDate'];
        if(trim($startDate)=='' && trim($endDate)==''){
            $startDate = $this->_getTranslation("Desde el inicio de los tiempos");
            $endDate = strftime('%d %m %Y',strtotime('now'));
        }elseif(trim($startDate)=='' && trim($endDate)!=''){
            $startDate = $endDate;
        }elseif(trim($startDate)!='' && trim($endDate)==''){
            $endDate = $startDate;
        }
        $this->setHeaderExcelReportManual($empresa['nombre']."\n".$this->_getTranslation($this->getTituloReporte())."\n".$startDate." - ".$endDate);
        
        if($formato == 'excel'){ 
            if(isset($this->reportesEspeciales[$this->options['report']])){ 

             $this->reporteEspecial();
            }else{
                $this->reporteDefault();
            }
        }elseif($formato == 'pdf'){
            if(isset($this->reportesEspecialesPDF[$this->options['report']])){
                $this->reporteEspecialPDF();
            }
        }      
    }
    
    public function reporteEspecial(){
        $data = $this->reporte;  
        include ROOT.'/View/Reports/Excel/'.$this->options['report'].".php";
    }
    
    public function getTemplateReporteOnScreen(){
        if(isset($this->reportesEspecialesPantalla[$this->options['report']])){
            return ROOT.'View/Reports/Pantalla/'.$this->options['report'].".php";
        }else{
            return ROOT.'View/Reports/Pantalla/default.php';
        }
    }
    
    public function reporteEspecialPDF(){
        $data = $this->reporte;
        include ROOT.'/View/Reports/Pdf/'.$this->options['report'].".php";
    }
    
     public function reporteDefault(){ 
        $arrayData = $this->reporte['data'];
        $colTitulosTemp = $arrayData[0];
       
        foreach($colTitulosTemp as $titulo => $value){
            $colTitulos[] = $titulo;
        }
        
        $objPHPExcel = new PHPExcel();
        $col = count($colTitulos);
        $lastCol = $this->getColLetter($col-1);

        $objPHPExcel->getActiveSheet()->mergeCells("A1:".$lastCol."1");            
        $objPHPExcel->getActiveSheet()->getRowDimension('1')->setRowHeight(50);
        $objPHPExcel->getActiveSheet()->getStyle("A1")->getFont()->setBold(true);
        $objPHPExcel->getActiveSheet()->setCellValue("A1", $this->headerExcelReport);
        $objPHPExcel->getActiveSheet()->getStyle('A1')->getAlignment()->setWrapText(true);
        $objPHPExcel->getActiveSheet()->getStyle("A1")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle("A1")->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);
            
        $objPHPExcel->getActiveSheet()->getStyle("A2:".$lastCol."2")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->getActiveSheet()->fromArray($colTitulos,NULL,'A2');    
           
        $row=3;
        foreach ($arrayData as $key => $data) {
            $i=0;
            foreach ($data as $col => $value) {
                $col = $this->getColLetter($i);
                $objPHPExcel->getActiveSheet()->setCellValue($col . $row, $value);
                $i++;
            }
            $row++;
        }
       
        foreach(range('A',$lastCol) as $columnID) {
            $objPHPExcel->getActiveSheet()->getColumnDimension($columnID)
                ->setAutoSize(true);
        } 
        $objPHPExcel->setActiveSheetIndex(0);
        // Redirect output to a client’s web browser (Excel2007)
        ob_end_clean();
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header("Content-Disposition: attachment;filename=".$this->getNombreArchivo().".xlsx");
        header('Cache-Control: max-age=0');
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
        $objWriter->save('php://output');
        unset($objWriter);
        exit;
    }
    
    public function saveFile(){
        $this->setTempFolder();
        $this->saveFile = true;
    }
    
    private function getColLetter($i){
        $colName = array("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","AA","AB","AC","AD","AE","AF","AG","AH","AI");
        
        return $colName[$i];
    }
    
    private function setTempFolder(){
        $login = new Login();
        $this->tempFolder = PATH_TEMP_DOCS.$login->getId();
        if(!is_dir($this->tempFolder)){
            mkdir($this->tempFolder,0777,true);
        }
    }
    
    private function getTempFolder(){
        return $this->tempFolder;
    }
    
    public function getFileSaved(){
        return $this->getTempFolder()."/".$this->getNombreArchivo().'.xlsx';
    }
}