<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

class AppointmentOptionsRepository extends EntityRepository {

    private $table = 'appointment_options';
    private $options = array(
        'day'=>null,
        'hours'=>null
    );
    
    public function setOptions($data){
      foreach ($this->options as $option => $value){
          if(isset($data[$option])){
            $this->options[$option] = $data[$option];
          }
      }
    }
  
    public function getOptions(){
        return $this->options;
    }
    
    public function getTable(){
        return $this->table;
    }

    public function save(array $data, $table = null) {
        $login = new Login();
        $data['creado_fecha'] = date('Y-m-d');
        $data['creado_por'] = $login->getId();
        unset($data['modificaciones']);
        
        if(is_array($data['hours']) && count($data['hours']) > 0){
            $sucursal = implode(',', $data['hours']);
            $data['hours'] = trim($sucursal,',');
        }        

        return parent::save($data, $this->table);
    }
    
    public function delete($id, $table = null) {        
        return parent::delete($id, $this->table);
    }

    public function update($id, $data, $table = null) {
        if(is_array($data['hours']) && count($data['hours']) > 0){
            $sucursal = implode(',', $data['hours']);
            $data['hours'] = trim($sucursal,',');
        }   
        
        unset($data['creado_fecha'],$data['creado_por'],$data['modificaciones']);
        
        return parent::update($id, $data, $this->table);
    }

    public function getById($id, $table = null,$selectAux = null) {
        return parent::getById($id, $this->table,$selectAux);
    }

    public function isUsedInRecord($id, array $buscarEn = null,$andWhere = null) {
        return parent::isUsedInRecord($id, array('productos' => 'marca'));
    }

    public function getListaSelectAppointmentOptions() {
        $select = "SELECT * FROM $this->table ";
        $result = $this->query($select);

        if ($result) {
            $array = array();
            while ($row = $result->fetch_assoc()) {
                $array[$row['id']] = $row['nombre'];
            }
            return $array;
        }
        return null;
    }
    
     public function getListaAppointmentOptions() {
        $select = "SELECT * FROM $this->table ";
        $result = $this->query($select);

        if ($result) {
           return $this->resultToArray($result);
        }
        return null;
    }
    
    public function getHoursOptionsByDay($dayNum) {
        $select = "SELECT * FROM $this->table WHERE day = '$dayNum' LIMIT 1";
        $result = $this->query($select);

        if($result->num_rows > 0) {
            $result = $this->resultToArray($result)[0];
            $hours = explode(',', $result['hours']);
            
            $array = array();
            foreach($hours as $hour){
                $array[$hour] = $hour;
            }
            
            return $array;           
        }
        return null;
    }
    
    public function getDayNameByDayNum($day_num){
        $day_names = array(
            '1'=>'Lunes',
            '2'=>'Martes',
            '3'=>'Miercoles',
            '4'=>'Jueves',
            '5'=>'Viernes',
            '6'=>'Sabado',
            '7'=>'Domingo',
        );
        
        return $day_names[$day_num];
    }
    
    public function getListStatus(){
        $query = "SELECT * FROM codigo_status WHERE tipo = 'Appointment'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $array = array();
            foreach($result as $status){
                $array[$status['codigo']] = $status['descripcion'];
            }
            return $array;
        }
        return null;
    }
    
    public function hoursStringToArray($sucursales){
        $arraySucursales = array();
        $sucursales = explode(',', $sucursales);
        foreach($sucursales as $key => $sucursal){
            $arraySucursales[$sucursal] = $sucursal;
        }
        return $arraySucursales;
    }
    
    public function _existDay($dayNum,$id){
        $query = "SELECT * FROM $this->table WHERE day = '$dayNum' AND id != '$id' ";
        $result = $this->query($query);
        
        if($result->num_rows >0){
            return true;
        }
        
        return null;
    }
}