<?php

include ROOT . '/class/Paginacion/Paginacion.php';
include ROOT . '/class/Paginacion/Tradicional.php';

class EntityRepository {
    
    private $id;
    private $lastInsertId = null;
    
    protected $_options = array();

    public function setId($id) {
        $this->id = $id;
    }

    public function getId() {
        return $this->id;
    }
    
    public function delete($id,$table){
        $select = "DELETE  FROM $table WHERE id = $id";
        $result = $this->query($select);
        
        if($result){
            return true;
        }        
        return null;
    }

    public function save(array $data, $table) {
        $tablesSaveModifications = array(
            'special_requisitions',
            'special_requisitions_details',
            'stores_shipments',
            'stores_shipments_details',
            'appointments',
            'preorders',
            'notifications',
            'purchases',
            'purchase_details',
            'supplie_returns',
            'supplie_returns_details',
            'supplie_outs',
            'supplie_outs_details',
            'pagos',
            'pagos_detalle',            
            'rewards_customers',
            'rewards_rules',
            'rewards_reedem',
            'categorias',
            'clientes',
            'payment_terms',
            'presentaciones',
            'products_details',
            'promotions',
            'receivings',
            'receivings_details',
            'requisitions',
            'requisitions_details',
            'stores_stock_templates',
            'stores_stock_template_details',
            'store_details',
            'sucursales',
            'supplie_and_service',
            'supplie_out_details',
            'timeclock',
            'unidades_de_medida',
            'usuarios'
        );
        
        if(in_array(trim($table), $tablesSaveModifications)){
            $login = new Login();
            $data['creado_por'] = $login->getId();
            $data['creado_fecha'] = date('Y-m-d H:i:s');
        }       
        
        $select = "INSERT INTO $table";
        $fields = "";
        $values = "";
        foreach ($data as $key => $value) {           
            if(!is_array($value)){
                $fields .= "`$key`,";
                $value = mysqli_real_escape_string(DataBase::getInstance(),$value);
                $values .= "'$value',";
            }else{         
                $fields .= "`{$value['key']}`,";
                $value['value'] = mysqli_real_escape_string(DataBase::getInstance(),$value['value']);
                $values .= "{$value['value']},";
            }            
            
        }
        $fields = substr($fields, 0, strlen($fields) - 1);
        $values = substr($values, 0, strlen($values) - 1);

        $select = $select . "(" . $fields . ") VALUES (" . $values . ")";
               
        return $this->query($select);        
    }
    
    public function getInsertId(){
        return DataBase::getInsertId();
    }
    
    public function setLastInsertId($id){
        $this->lastInsertId = $id;
    }
    
    public function getLastInsertId(){
        return $this->lastInsertId;
    }

    public function update($id, $fields, $table) {
        $tablesSaveModifications = array(
            'clientes',
            'special_requisitions',
            'special_requisitions_details',
            'stores_shipments',
            'stores_shipments_details',
            'appointments',
            'preorders',
            'notifications',
            'purchases',
            'purchase_details',
            'supplie_returns',
            'supplie_returns_details',
            'supplie_outs',
            'supplie_outs_details',            
            'rewards_settings',
            'rewards_rules',
            'rewards_reedem',
            'categorias',
            'clientes',
            'payment_terms',
            'presentaciones',
            'products_details',/*Esta cambios nunca se guardan porque realmente los detalles de producto no se editan, se borra y se crea uno nuevo cuando se edita*/
            'promotions',
            'receivings',
            'receivings_details',
            'requisitions',
            'requisitions_details',
            'stores_stock_templates',
            'stores_stock_template_details',
            'store_details',
            'sucursales',
            'supplie_and_service',
            'supplie_out_details',
            'timeclock',
            'unidades_de_medida',
            'usuarios'
        );        
      
       if(in_array(trim($table),$tablesSaveModifications)){
            $originData = EntityRepository::getById($id, $table);                        
            $modifications = $this->getUpdatedFields($originData,$fields);      
            
            if($modifications){
                $login = new Login();
                $modificadoPor = $login->getId();
                $modificadoFecha = date('Y-m-d H:i:s');

                $fields['ultima_mod_por'] = $modificadoPor;
                $fields['ultima_mod_fecha'] = $modificadoFecha;              
                $fields['modificaciones'] = $this->getModifications($originData,$modifications);
            }
        }
        
        $select = "UPDATE $table SET ";
        foreach ($fields as $key => $value) {
            if(!is_array($value)){
                $value = mysqli_real_escape_string(DataBase::getInstance(),$value);
                if($value == '_NULL' || is_null($value) || trim($value)==''){
                 $select .= "`$key` = NULL,";
                }else{
                    $select .= "`$key` = '$value',";
                }  
            }else{                
                $value['value'] = mysqli_real_escape_string(DataBase::getInstance(),$value['value']);
                $select .= "`{$value['key']}` = {$value['value']},";
            }            
            
            
        }

        $select = substr($select, 0, strlen($select) - 1);
        $select .= " WHERE id = $id";
        //echo $select;exit;
        return  $this->query($select);
    }
    
    public function updateString($fields,$where,$table) {
        $select = "UPDATE $table SET ";
        foreach ($fields as $key => $value) {
            if($value == '_NULL' || is_null($value) || trim($value)==''){
                $select .= "$key = NULL,";
            }else{
               $select .= "$key = '$value',";
            }            
        }

        $select = substr($select, 0, strlen($select) - 1);
        $select .= " WHERE ".$where;
        //echo $select;
        return  $this->query($select);
    }

    public function getById($id, $table,$selectAux = null) {
        $select = "SELECT * ";
        if($selectAux){$select .= ",$selectAux";}
        
        $select = "$select FROM $table WHERE id = '$id'";

        $result = $this->query($select);

        if ($result->num_rows>0) {
            $set = $this->resultToArray($result);
            return $set[0];
        }

        return null;
    }
    
    public function isUsedInRecord($id,array $buscarEn, $andWhere = null){
        foreach($buscarEn as $key => $value){
            $select = "SELECT id FROM $key WHERE $value = '$id' $andWhere limit 1";
            $result = $this->query($select);
            if($result->num_rows > 0){
                $result = $result->fetch_object();
                return array('id'=>$result->id,'table'=>$key);
            }
        }
        
        return null;
    }
    
     public function getUpdatedFields($originData,$newData){
        #regresa un array con los campos que se actualizaron
        if(is_array($originData)){
            $modifications = array();
            //var_dump($newData);exit;
            foreach($originData as $key => $value){
                if(key_exists($key, $newData) && $newData[$key] !== '_NULL' && trim($newData[$key]) != trim($value)){
                    $modifications[$key] = $originData[$key];
                }
            }
            if(count($modifications) > 0){
                return $modifications;
            }
        }
        return null;
    }
    
    public function getModifications($originData,$modifications){
        #regresa un array de arrays serializado donde cada array es un campo que se actualizo array(campo=>valorAnterior)
        $login = new Login();
        $modifications = array('fecha'=>date('Y-m-d H:i:s'),'usuario'=>$login->getId(),'modificaciones'=>$modifications);
        if(isset($originData['modificaciones']) && trim($originData['modificaciones'])!==''){
            $originModifications = unserialize($originData['modificaciones']);
            $originModifications[] = $modifications;

            return serialize($originModifications);
        }else{
            return serialize(array($modifications));
        }         
    }
    
    public function query($query){ 
        $result = DataBase::getInstance()->execute($query);
        return $result;
    }
    
    public function resultToArray($result){
        for ($set = array(); $row = $result->fetch_assoc(); $set[] = $row);
  
        return $set;
    }
    
    public function startTransaction(){
        return $this->query('START TRANSACTION');
    }
    
    public function commit(){
        return $this->query('COMMIT');
    }
    
    public function rollback(){
        return $this->query('ROLLBACK');
    }
    
    public function setBackButton($controller){
        $url = "/Controller/$controller.php?".$this->getQueryVarsFromGET();
        $_SESSION['back_button'] = "<a href='$url' class='btn btn-default btn-sm' style='float:left;margin-right: 10px'><span class='fa fa-arrow-circle-left'></span> Back</a>";
    }
    
    public function getBackButton(){
        return $_SESSION['back_button'];
    }
    
    public function getQueryVarsFromGET($noReturn = array()){
        $queryVars='';
        foreach ($_GET as $clave => $valor){
          if(!in_array($clave,$noReturn)){
          $queryVars .= $clave . "=" . $valor . "&amp;";
        }
      }
        return $queryVars;
    } 
    
    /*******************************************/
    /*********** IMPORT FROM EXCEL *************/
    /*******************************************/
    
    public function import(Importable $data) { 
        try {
            if (!$data->isUploaded()) {
                $data->upload();
            }
            $data->setEntity($this);
            if (!$data->save($this)) {
                throw new Exception($data->getFeedbackMsg());
            }
            return true;
        } catch (Exception $exc) {
            $this->flashmessenger->addMessage(array(
                'danger' => $exc->getMessage(),
            ));
            return false;
        }            
    }
    
    public function insert($data) {
        try {
//            TODO: Need to talk with Carlos to move this code to another place, looks like it is tied to a specific entity type;
//            $dataTemp = $data[0];
//            $query = "DELETE FROM {$this->getTableName()} WHERE YEAR = {$dataTemp['YEAR']} AND MONTH  = {$dataTemp['MONTH']}";
//            $this->query($query);

            foreach ($data as $row) {
                if (!is_array($row)) {
                    $this->save($data,$this->getTableName());
                    break;
                }
               $this->save($row,$this->getTableName());
            }
            return true;
        } catch(Exception $exc) {
            throw new Exception("There was a problem trying to import the data: <strong>{$exc->getMessage()}</strong>");
        } catch (Exception $exc) {
            throw $exc;
        }
    }

    protected function camelize($option) {
        return 'set' . str_replace(' ', null, ucwords(str_replace('_', ' ', strtolower($option))));
    }

    public function setOptionsAssoc($optionsAssoc) {
        foreach($optionsAssoc as $key => $value) {
            $this->setOption($key, $value);
        }
    }

    public function setOptions($options) {
        for ($i = 0, $keys = array_keys($this->_options), $size = count($this->_options);
             $i < $size;
             $this->setOption($keys[$i], $options[$i]));
    }

    public function setOption($option, $value) {
        $camelized = $this->camelize($option);
        if (method_exists($this, $this->camelize($option))) {
            $this->$camelized($value);

            return $this;
        }

        if (key_exists($option, $this->_options)) {
            $this->_options[$option] = $value;
        }

        return $this;
    }

    public function __set($name, $value) {
        $this->setOption($name, $value);
    }
    
    public function __get($name) {
        if (isset($this->_options[$name])) {
            return $this->_options[$name];
        }

        return null;
    }
}