<?php
class InventorySupplieRepository extends EntityRepository {

    private $table = 'inventory_supplies';    
    private $last_insert_id_inventory = null;
    
    public $flashmessenger = null;
    var $options = array(
        'idProduct'=>null,
        'quantity'=>null,
        'location'=>null,
        'controller'=>null
    );
    
    public function __construct() {
        if(!$this->flashmessenger instanceof FlashMessenger){
            $this->flashmessenger = new FlashMessenger();
        }
    }
    
    public function setOptions($data){
      foreach ($this->options as $option => $value){
          if(isset($data[$option])){
            $this->options[$option] = $data[$option];
          }
      }
    }   
    
    public function _getTranslation($text){
        return $this->flashmessenger->_getTranslation($text);
    } 
  
    public function getOptions(){
        return $this->options;
    }
    
    public function getLastInsertIdInventory() {
        return $this->last_insert_id_inventory;
    }

    public function save(array $data, $table = null) {
        foreach($data as $field => $value){if($value === '' || $value === null){$data[$field] = '_NULL';}}
        $entityRepository = new EntityRepository();
        $result = $entityRepository->save($data, $this->table);
        
        return $result;
    }
    
    public function update($id, $data, $table = null) {         
        return parent::update($id, $data, $this->table);
    }    
    
    public function delete($id, $table = null) {
        return parent::delete($id, $this->table);     
    }
    
    public function getById($id, $table = null,$selectAux = null) {
        return parent::getById($id, $this->table,$selectAux);
    }    
    
    public function getLocationForProduct($idProduct){
        $query = "SELECT GROUP_CONCAT(DISTINCT(location))as location "
                . "FROM $this->table "
                . "WHERE idProduct = '$idProduct' ";
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $result->fetch_object();
            return $result->location;
        }
        
        return null;
    }
    
    public function getByIdProduct($idProduct){
        $query = "SELECT * FROM $this->table where idProduct = '$idProduct'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result)[0];
        }
        return null;
    }
    
    public function getByIdProductAndLocation($data){
        $query = "SELECT * FROM $this->table where idProduct = '{$data['idProduct']}' AND location = '{$data['location']}'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result)[0];
        }
        return null;
    }
    
    public function addInventory($data){
        $quantity = $data['quantity'];
        
        if($quantity != '0'){
            $currentData = $this->getByIdProductAndLocation($data);         
            if($currentData !== null){                 
                $currentStock = $currentData['quantity'];                
                $currentStock += $quantity;               
                $data['quantity'] = $currentStock;
                
                return parent::update($currentData['id'],array('quantity'=>$data['quantity'],'controller'=>$data['controller']), $this->table);  
            }else{      
                $this->setOptions($data);
                //var_dump($data);exit;
                return parent::save($this->getOptions(), $this->table);
            }          
        }        
        return true;
    }  
    
    public function subInventory($data){
        $quantity = $data['quantity'];
     
        if($quantity != '0'){
            $currentData = $this->getByIdProductAndLocation($data);
            if($currentData != null){
                $currentStock = $currentData['quantity'];    
                if($currentStock < $quantity){
                    //$this->flashmessenger->addMessage(array('info'=>"No hay stock suficiente del pallet {%{$currentData['id_pallet']}%}."));
                    //return null;
                }
                
                $currentStock -= $quantity;                  
                $data['quantity'] = $currentStock;
                //echo $currentData['id'];exit;
                return parent::update($currentData['id'],array('quantity'=>$data['quantity'],'controller'=>$data['controller']), $this->table);            
            }else{
                $data['quantity'] = $data['quantity'] * -1;
                $this->setOptions($data);
                return parent::save($this->getOptions(), $this->table);
            }              
        }        
        return true;
    }
    
    public function editInventory($data){        
        $rs = true;        
        $currentQuantity = $data['current_quantity'];
        $newQuantity = $data['quantity'];       
        $currentLocation = $data['current_location'];
        $newLocation = $data['location'];       
        //var_dump($data);exit;
        
        $login = new Login();        
        //$data['controller'] = 'Manual - Usuario '.$login->getCompleteName();
        
        if($currentLocation != $newLocation){           
            $data['location'] = $currentLocation;
            $data['quantity'] = $currentQuantity;
            $this->subInventory($data);

            $data['location'] = $newLocation;
            $data['quantity'] = $newQuantity;
            $this->addInventory($data);  
            
        }else{
            $diff = $newQuantity - $currentQuantity;

            if($diff > 0){            
                $data['quantity'] = $diff;
                $rs = $this->addInventory($data);
            }elseif($diff < 0){
                $data['quantity'] = abs($diff);
                $rs = $this->subInventory($data);  
            }                
        }         
        return $rs;
    }  
    
     public function editSubInventory($data){        
        $rs = true;        
        $currentQuantity = $data['current_quantity'];
        $newQuantity = $data['quantity'];       
        $currentLocation = $data['current_location'];
        $newLocation = $data['location'];       
        //var_dump($data);exit;
        
        if($currentLocation != $newLocation){           
            $data['location'] = $currentLocation;
            $data['quantity'] = $currentQuantity;
            $this->subInventory($data);

            $data['location'] = $newLocation;
            $data['quantity'] = $newQuantity;
            $this->addInventory($data);    
            
        }else{
            $diff = $newQuantity - $currentQuantity;

            if($diff < 0){            
                $data['quantity'] = abs($diff);
                $rs = $this->addInventory($data);
            }elseif($diff > 0){
                $data['quantity'] = $diff;
                $rs = $this->subInventory($data);  
            }                
        }         
        return $rs;
    }  
    
    public function changeLocation($data){       
        /* Restar de locacion actual */
        $rs = $this->subInventory(array(
                    'idProduct'=>$data['idProduct'],
                    'location'=>$data['old_location'],
                    'quantity'=>$data['quantity'],
                    'controller'=>$data['controller']
                ));
        
        if($rs){
            /* Sumar a locacion nueva */
            $rs = $this->addInventory(array(
                'idProduct'=>$data['idProduct'],
                'location'=>$data['new_location'],
                'quantity'=>$data['quantity'],
                'controller'=>$data['controller']
            ));
        }
        
        
       return $rs;
    }
    
    public function editChangeLocation($data){
        $rs = true;
        if($data['origin_new_location'] !== $data['new_location']){
            $rs = $this->deleteChangeLocation(array(            
                'idProduct'=>$data['idProduct'],
                'old_location'=>$data['origin_old_location'],
                'new_location'=>$data['origin_new_location'],
                'quantity'=>$data['origin_quantity'],
                'controller'=>$data['controller']
            ));
            
            if($rs){
                /* Restar de locacion actual */
                $rs = $this->subInventory(array(
                            'idProduct'=>$data['idProduct'],
                            'location'=>$data['origin_old_location'],
                            'quantity'=>$data['quantity'],
                            'controller'=>$data['controller']
                        ));

                if($rs){
                    /* Sumar a locacion nueva */
                    $rs = $this->addInventory(array(
                        'idProduct'=>$data['idProduct'],
                        'location'=>$data['new_location'],
                        'quantity'=>$data['quantity'],
                        'controller'=>$data['controller']
                    ));
                }
            }           
        }else{
            /*Locacion es nueva es igual*/
            $diff = $data['quantity'] - $data['origin_quantity'];
            if($diff > 0){                
                $data['quantity'] = $diff;
                
                $rs = $this->addInventory(array(
                        'idProduct'=>$data['idProduct'],
                        'location'=>$data['new_location'],
                        'quantity'=>$data['quantity'],
                        'controller'=>$data['controller']
                    ));
                
                $rs = $this->subInventory(array(
                        'idProduct'=>$data['idProduct'],
                        'location'=>$data['old_location'],
                        'quantity'=>$data['quantity'],
                        'controller'=>$data['controller']
                    ));
                
            }elseif($diff < 0){
                $data['quantity'] = abs($diff);
                $rs = $this->addInventory(array(
                        'idProduct'=>$data['idProduct'],
                        'location'=>$data['old_location'],
                        'quantity'=>$data['quantity'],
                        'controller'=>$data['controller']
                    ));
                
                $rs = $this->subInventory(array(
                        'idProduct'=>$data['idProduct'],
                        'location'=>$data['new_location'],
                        'quantity'=>$data['quantity'],
                        'controller'=>$data['controller']
                    ));
            }   
        }
        
        return $rs;        
    }
    
    public function deleteChangeLocation($data){
        /* Restar de locacion nueva */
        $rs = $this->subInventory(array(
                    'idProduct'=>$data['idProduct'],
                    'location'=>$data['new_location'],
                    'quantity'=>$data['quantity'],
                    'controller'=>$data['controller']
                ));
        
        if($rs){
            /* Sumar a locacion original */
            $rs = $this->addInventory(array(
                'idProduct'=>$data['idProduct'],
                'location'=>$data['old_location'],
                'quantity'=>$data['quantity'],
                'controller'=>$data['controller']
            ));
        }
        
       return $rs;
    }
    
    public function isAvailableStock($id,$quantity){
        $query = "SELECT quantity as stock FROM $this->table WHERE id = '$id'";
        $result = $this->query($query);

        if($result->num_rows > 0){
            $result = $result->fetch_object();
            if($result->stock >= $quantity){
                return array(
                    'response'=>true
                );
            }else{
                return array(
                    'response'=>null,
                    'stock'=>$result->stock
                );
            }
        }

        return array(
                    'response'=>null,
                    'stock'=>'0'
                );
    }      
    
    public function currentInventoryProductCost($idProduct){
        $query = "SELECT idProduct,SUM(quantity)as quantity,average_cost FROM $this->table WHERE idProduct = '$idProduct'";
        $result = $this->query($query);
        
        if($result->num_rows> 0){
           return $this->resultToArray($result)[0];
        }
        
        return null;
    }
        
    public function getTable(){
        return $this->table;
    }    
    
    public function saveLastEntry($data){
        $query = "UPDATE $this->table SET lastCost = '{$data['cost']}', lastEntry = '{$data['quantity']}' WHERE idProduct = '{$data['idProduct']}'";
        $result = $this->query($query);
        
        if($result){
            return true;
        }
        
        return null;
    }
    
    /*Cuando se recibe lastMonth se guarda inventario en tbl month_end_inventory*/
    /*Sino se recibe se actualiza la tbl inventario_supplies */
    public function calculateAverageCost($lastMonth = null){
        $entityRepository = new EntityRepository();
        $sufijo = date('YmdGis');

        /*CREAR TABLA TEMPORAL DE INVENTARIO*/
        $query = "CREATE TEMPORARY TABLE _temp_inventory_supplies_".$sufijo." 
                      (  `id` int(11) NOT NULL AUTO_INCREMENT,
                         `idProduct` int(11) NULL,
                         `quantity` double NULL,                    
                         `location` int(11) NOT NULL,
                         `average_cost` double NULL,
                         `lastEntry` double NULL,
                         `lastCost` double NULL,
                         PRIMARY KEY (`id`)
                      )ENGINE=InnoDB DEFAULT CHARSET=utf8;";

         $entityRepository->query($query);

         /*INSERTAR INVENTARIO ACTUAL EN TABLA TEMPORAL*/
         $query = "INSERT INTO _temp_inventory_supplies_{$sufijo} (idProduct,quantity,location,average_cost,lastEntry,lastCost)"
                 . "SELECT idProduct,quantity,location,average_cost,lastEntry,lastCost FROM inventory_supplies  ";

         $entityRepository->query($query);    

         /*SET COSTO PROMEDIO DONDE STOCK ES MENOR A CANTIDAD EN ULTIMA COMPRA*/
         $query = "UPDATE _temp_inventory_supplies_{$sufijo} i "
                 . "SET i.average_cost = i.lastCost "
                 . "WHERE i.quantity < i.lastEntry ";

         $entityRepository->query($query);    

         /* CALCULAR COSTO PROMEDIO TOTAL */
         
         $query = "SELECT * FROM pre_costo_promedio";
         $result = $entityRepository->query($query);

         if($result->num_rows > 0){
             $result = $entityRepository->resultToArray($result);
             foreach($result as $row){
                 if($row['quantity_en_compra'] < $row['stock']){
                     $faltante = $row['stock'] - $row['quantity_en_compra'];
                     
                     $query1 = "SELECT d.* "
                         . "FROM store_in s,store_in_details d "
                         . "WHERE s.id = d.id_store_in "
                         . "AND d.id < '{$row['detail_id']}' "
                         . "AND idProduct = '{$row['idProduct']}' "
                         . "AND s.status != '3' "
                         . "ORDER BY id DESC "
                         . "LIMIT 1";

                    $result1 = $entityRepository->query($query1);
                    if($result1->num_rows > 0){
                        $result1 = $result1->fetch_object();
                                                
                        $entityRepository->query("UPDATE _temp_inventory_supplies_{$sufijo} "
                                                . "SET average_cost = (( {$row['quantity_en_compra']} * {$row['av_cost']}) +  ( ($result1->total / {$result1->quantity}) * $faltante)  )/ ({$row['quantity_en_compra']} + {$faltante}) "
                                                . "WHERE idProduct = '{$row['idProduct']}' ");                  
                    }         
                     
                 }else{
                        $entityRepository->query("UPDATE _temp_inventory_supplies_{$sufijo} "                                                
                                                . "SET average_cost = {$row['av_cost']} "
                                                . "WHERE idProduct = '{$row['idProduct']}' ");                      
                 }                    
             }
         }    
         
        if($lastMonth){
            $query = "INSERT INTO month_end_inventory (idProduct,quantity,location,average_cost,month) "
                . "SELECT idProduct,quantity,location,average_cost,'{$lastMonth}' FROM _temp_inventory_supplies_{$sufijo} ";
        }else{
            $query = "UPDATE inventory_supplies i, _temp_inventory_supplies_{$sufijo} tis "
                    . "SET i.average_cost = tis.average_cost "
                    . "WHERE i.idProduct = tis.idProduct ";
        }
        
        
        $entityRepository->query($query);           

    }       
}
