<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

class MailboxRepository extends EntityRepository {
    public $flashmessenger = null;
    private $options = array();
    
    public function __construct() {
        if(!$this->flashmessenger instanceof FlashMessenger){
            $this->flashmessenger = new FlashMessenger();
        }
    }
    
    public function setOptions($data){
      foreach ($this->options as $option => $value){
          if(isset($data[$option])){
            $this->options[$option] = $data[$option];
          }
      }
    }
  
    public function getOptions(){
        return $this->options;
    }
    
    public function getTable(){
        return $this->table;
    }

    public function saveResponse(array $data, $table = null) {    
        $login = new Login();
        $array = array(
            'notification_id'=>$data['notification_id'],
            'notification_sent_id'=>$data['id'],
            'message'=>$data['message'],
            'response_date'=>date('Y-m-d H:i:s'),
            'response_by'=>$login->getId()
        );
        
        return parent::save($array, 'notifications_response');        
    }
    
    public function delete($id, $table = null) {        
        return parent::delete($id, $table);
    }

    public function update($id, $data, $table = null) {        
        return parent::update($id, $data, $this->table);
    }

    public function getById($id, $table = null,$selectAux = null) {
        $select = "SELECT a.*,"
                . "DATE_FORMAT(a.when_send,'%m/%d/%Y %h:%i %p')as when_send,"
                . "DATE_FORMAT(a.repeat_from,'%m/%d/%Y')as repeat_from,"
                . "DATE_FORMAT(a.repeat_to,'%m/%d/%Y')as repeat_to,"
                . "TIME_FORMAT(a.repeat_hour,'%h:%i %p')as repeat_hour,"
                . "fxGetUserName(a.creado_por)as created_by_name, "
                . "DATE_FORMAT(a.creado_fecha,'%m/%d/%Y %h:%i %p')as created_date,"
                . "fxGetStatusName(a.status,'status','Notification')as status_name "
                . "FROM notifications_sent a "
                . "WHERE a.id = '$id' "
                . "LIMIT 1";
        $result = $this->query($select);

        if ($result->num_rows > 0) {
           return $this->resultToArray($result)[0];
        }
        return null;
    }

    public function isUsedInRecord($id, array $buscarEn = null,$andWhere = null) {
        return parent::isUsedInRecord($id, array('productos' => 'marca'));
    }
    
    public function getListMessages($userId){
        $select = "SELECT n.*,"
                . "s.id as message_id,"
                . "fxGetUserName(n.creado_por)as created_by_name, "
                . "IF(s.reading_date IS NULL,1,0)as unread,"
                . "DATE_FORMAT(MAX(sent_date),'%m/%d/%Y %h:%i %p')as sent_date "
                . "FROM notifications_sent s  "
                . "LEFT JOIN notifications n ON s.notification_id = n.id "
                . "WHERE 1 = 1 "
                . "AND user_id = '$userId' "
                . "GROUP BY s.id "
                . "ORDER BY s.sent_date DESC";
        $result = $this->query($select);

        if ($result) {
           return $this->resultToArray($result);
        }
        return null;
    }
    
    public function  getByMessageId($id){
        $select = "SELECT n.*,"
                . "n.id as notification_id,"
                . "s.id as message_id,"
                . "fxGetUserName(n.creado_por)as created_by_name, "
                . "IF(s.reading_date IS NULL,1,0)as unread,"
                . "DATE_FORMAT(MAX(sent_date),'%m/%d/%Y %h:%i %p')as sent_date "
                . "FROM notifications_sent s  "
                . "LEFT JOIN notifications n ON s.notification_id = n.id "
                . "WHERE 1 = 1 "
                . "AND s.id = '$id' "
                . "GROUP BY s.id ";
        $result = $this->query($select);

        if ($result) {
           return $this->resultToArray($result)[0];
        }
        return null;
    }
    
    public function getResponsesByMessageId($id){
        $query = "SELECT *,"
                . "fxGetUserName(response_by)as user_name,"
                . "DATE_FORMAT(response_date,'%m/%d/%Y %h:%i %p')as formated_response_date "
                . "FROM notifications_response "
                . "WHERE notification_sent_id = '$id' "
                . "ORDER BY response_date DESC";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result);
        }
        
        return null;        
    }
    
    public function setAsRead($id){
        $query = "SELECT * FROM notifications_sent WHERE id = '$id' AND reading_date IS NULL";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $query = "UPDATE notifications_sent SET reading_date = NOW() WHERE id = '$id'";
            
            return $this->query($query);            
        }
        
        return true;
    }
}