<?php
class PurchaseDetailsTempRepository extends EntityRepository {

    private $table = 'purchase_details_';
    
    private $options = array(
        'token_form'=>null,
        'id_detail'=>0,
        'id_purchase'=>0,
        'location_id'=>null,
        'id_product'=>null,
        'description'=>null,
        'description_details'=>null,
        'quantity'=>null,
        'cost'=>null,
        'discount'=>null,
        'discount_type'=>null,
        'discount_amount'=>0,
        'discount_general'=>null,
        'discount_general_type'=>null,
        'discount_general_amount'=>0,
        'taxes'=>0,
        'taxes_rate'=>0,
        'taxes_amount'=>0,
        'amount'=>0,
        'total'=>0,
    );
    
    private $options_aux = array();
    
    /*Input double y que no son hide*/
    public $inputs_double = array(
        'quantity','cost','discount','discount_amount','discount_general','discount_general_amount','amount','total','discount_items'
    );
    
    public function __construct(){
        $login = new Login();
        $this->table = $this->table.$login->getId();
    }
    
    public function setOptions($data){
      foreach ($this->options as $option => $value){
          if(isset($data[$option])){
            $this->options[$option] = $data[$option];
          }
      }
      
      foreach ($this->options_aux as $option => $value){
            if(isset($data[$option])){
              $this->options_aux[$option] = $data[$option];
            }
        }
    }
    
    public function getOptions(){
        $notNullNoEmpty = array('discount','discount_general');
        foreach($notNullNoEmpty as $key => $value){
            if(trim($this->options[$value]) == '' || is_null($this->options[$value])){
                $this->options[$value] = 0;
            }
        }
        
        return $this->options;
    }     
    
    public function restartOptions(){
        foreach ($this->options as $option => $value){
            $this->options[$option] = null;
        }
    }
    
    // Guarda en temporal
    public function save(array $data, $table = null) {
        $tools = new Tools();               
        $idDetailTemp = $data['idDetailTemp'];
        
        $this->setOptions($data);
        $data = $this->getOptions();
        unset($data['id_detail'],$data['id_purchase']);
        
        if(isset($idDetailTemp) && trim($idDetailTemp)!= ''){
            $result = $this->getById($idDetailTemp);
            if($result){                
                return $this->updateTemp($idDetailTemp,$data);
            }
        }
        
        return $this->saveTemp($data);
    }
    
    public function saveTemp($data){       
        $repoProduct = new SupplieAndServiceRepository();  
        $dataTax = $repoProduct->getDataTaxesById($data['taxes']);             
        
        $discount_amount = 0;        
        $subtotal = round($data['cost'] * $data['quantity'],4,PHP_ROUND_HALF_UP);
        $importe = $subtotal;
        
        #Descuento aplicado a item
        if(trim($data['discount']) !== '' && !is_null($data['discount'])){
            if($data['discount_type'] == 'porcentaje'){
                $discount_amount = round($importe * ($data['discount']/100),4,PHP_ROUND_HALF_UP);
                $importe = $importe - $discount_amount;
            }elseif($data['discount_type'] == 'monto'){
                $discount_amount = $data['discount'];
                $importe = $importe - $data['discount'];     
            }
        }        
        
        $taxes_amount =  round($importe * ($dataTax['impuestos_tasa']/100),4,PHP_ROUND_HALF_UP);        
        $data['discount_amount'] =  round($discount_amount,2,PHP_ROUND_HALF_UP);
        $data['taxes_rate'] = $dataTax['impuestos_tasa'];
        $taxes_amount = round($taxes_amount,2,PHP_ROUND_HALF_UP);
        $data['taxes_amount'] = $taxes_amount;
        $importe = round($importe,2,PHP_ROUND_HALF_UP);
        $data['amount'] = $importe;
        $data['total'] = $importe + $taxes_amount;       
        
        parent::save($data, $this->table);
    }
    
    public function updateTemp($id,$data){
        $repoProduct = new SupplieAndServiceRepository();  
        $dataTax = $repoProduct->getDataTaxesById($data['taxes']);             
        
        $discount_amount = 0;        
        $subtotal = round($data['cost'] * $data['quantity'],4,PHP_ROUND_HALF_UP);
        $importe = $subtotal;
        
        #Descuento aplicado a item
        if(trim($data['discount']) !=='' && !is_null($data['discount'])){ 
            if($data['discount_type'] == 'porcentaje'){
                $discount_amount = round($importe * ($data['discount']/100),4,PHP_ROUND_HALF_UP);
                $importe = $importe - $discount_amount;
            }elseif($data['discount_type'] == 'monto'){
                $discount_amount = $data['discount'];
                $importe = $importe - $data['discount'];                      
            }
        }        

        $taxes_amount =  round($importe * ($dataTax['impuestos_tasa']/100),4,PHP_ROUND_HALF_UP);        
        $data['discount_amount'] =  round($discount_amount,2,PHP_ROUND_HALF_UP);
        $data['taxes_rate'] = $dataTax['impuestos_tasa'];
        $taxes_amount = round($taxes_amount,2,PHP_ROUND_HALF_UP);
        $data['taxes_amount'] = $taxes_amount;
        $importe = round($importe,2,PHP_ROUND_HALF_UP);
        $data['amount'] = $importe;
        $data['total'] = $importe + $taxes_amount;  
        
        unset($data['discount_general_type'],$data['discount_general'],$data['discount_general_amount']);
        parent::update($id,$data, $this->table);
    }
    
    // Guarda en tabla comprasdetalles
    public function saveDetalles($idCompra,$tokenForm,$purchaseNumber){
        $query = "SELECT d.*,"
                . "g.llevar_inventario "
                . "FROM $this->table d "
                . "LEFT JOIN supplie_and_service g ON d.id_product = g.id "
                . "WHERE d.token_form = '$tokenForm'";
        $result = $this->query($query);
        if($result->num_rows > 0){
           
            $result = $this->resultToArray($result);
            $inventorySupplyRepo = new InventorySupplieRepository();
            
            foreach($result as $data){              
                $llevar_inventario = $data['llevar_inventario'];
                $this->setOptions($data);
                $data = $this->getOptions();            
                $data['id_purchase'] = $idCompra; 
                $data['cost_without_tax'] = $data['cost'];
                
                unset($data['token_form'],$data['id_detail'],$data['llevar_inventario']);               
                if(parent::save($data, 'purchase_details')){
                    if($llevar_inventario == 'Si'){
                        $inventorySupplyRepo->addInventory(array(
                            'location'=>$data['location_id'],
                            'idProduct'=>$data['id_product'],
                            'quantity'=>$data['quantity'],
                            'controller'=>"Compra # - $purchaseNumber"));
                    }
                    
                }else{
                    return null;
                }
            }
            return true;
        }
        return true;
    } 
    
    public function updateDetalles($idPurchase,$tokenForm,$purchaseNumber){                
        $query = "SELECT id,id_product,quantity,location_id FROM purchase_details WHERE id_purchase = '$idPurchase'";
        $result = $this->query($query);
        $detallesOrigin = null;    
        if($result->num_rows > 0){
            $detallesOrigin = $this->resultToArray($result);
        }
        
        $query = "SELECT d.*, "
                . "g.llevar_inventario "
                . "FROM $this->table d "
                . "LEFT JOIN supplie_and_service g ON d.id_product = g.id "
                . "WHERE d.token_form = '$tokenForm'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $idsDetalles = array();
        
            $result = $this->resultToArray($result);
            $inventorySupplyRepo = new InventorySupplieRepository();   
            $purchaseGoodServiceRepo = new PurchaseRepository();
            
            foreach($result as $data){
                $idDetalle = $data['id_detail'];
                $llevar_inventario = $data['llevar_inventario'];
                
                $this->setOptions($data);
                $data = $this->getOptions();     
                $this->restartOptions();

                $data['id_purchase'] = $idPurchase;   
                $data['cost_without_tax'] = $data['cost'];                
                unset($data['token_form'],$data['id_detail'],$data['llevar_inventario']);               
               
                if(!$idDetalle){
                    if(parent::save($data, 'purchase_details')){
                        if($llevar_inventario == 'Si'){
                            /*Agregar a inventario*/
                            $inventorySupplyRepo->addInventory(array(
                                'location'=>$data['location_id'],
                                'idProduct'=>$data['id_product'],
                                'quantity'=>$data['quantity'],
                                'controller'=>"Compra # - $purchaseNumber"));
                        }                        
                    }else{
                        return null;
                    }                    
                }else{
                    #contiene los idDetalles de la compra original que se mantendran, lo que no esten aqui se eliminaran.
                    $idsDetalles[] = $idDetalle;
                    $detalleData = $purchaseGoodServiceRepo->getPurchaseGoodAndServiceDetailSaved($idDetalle);
                   
                    if(parent::update($idDetalle,$data, 'purchase_details')){     
                        if($llevar_inventario == 'Si'){ 
                            $inventorySupplyRepo->editInventory(array(
                                'current_location'=>$detalleData['location_id'],
                                'location'=>$data['location_id'],
                                'idProduct'=>$data['id_product'],
                                'current_quantity'=>$detalleData['quantity'],
                                'quantity'=>$data['quantity'],
                                'controller'=>"Editar detalle Compra # - {$detalleData['purchase_number']}"
                            ));     
                        }                         
                    }else{
                        return null;
                    }
                }  
            }
        }else{
            $this->flashmessenger->addMessage(array('danger'=>'Error 26052021. Algo salio mal al tratar de actualizar el registro.'));
            header("Location: Purchase.php?action=edit&id=$idPurchase");
            exit;
        }
        
        #Se eliminan ids de tabla comprasdetalls que ya no estan en $idsDetalles (este array contiene los ids que permanececieron en la compra despues del update)                
        if($detallesOrigin){
            foreach ($detallesOrigin as $detalle){
                if(!in_array($detalle['id'], $idsDetalles)){
                    if(parent::delete($detalle['id'], 'purchase_details')){
                       /*Agregar a inventario*/
                        $rs = $inventorySupplyRepo->subInventory(array(
                            'location'=>$detalle['location_id'],
                            'idProduct'=>$detalle['id_product'],
                            'quantity'=>$detalle['quantity'],
                            'controller'=>"Eliminar detalle Compra # - $purchaseNumber"));
                    }else{
                        return null;
                    }
                }
            }
        }  
        return true;
    }
    
    public function delete($id, $table = null) {
        return parent::delete($id, $this->table);
    }
    
    public function truncate($tokenForm){
         $query = "DELETE  FROM ".$this->table." WHERE token_form = '$tokenForm'";
        $result = $this->query($query);
        
        if($result){
            return true;
        }
        
        return null;
    }
    
    public function setPurchaseDetailsById($idPurchase,$tokenForm){
        $query = "INSERT INTO ".$this->table." (
                    id_detail,
                    token_form,                   
                    location_id,
                    id_purchase,
                    id_product,
                    description,
                    description_details,
                    quantity,
                    cost,
                    discount,
                    discount_type,
                    discount_amount,
                    discount_general,
                    discount_general_type,
                    discount_general_amount,
                    taxes,
                    taxes_rate,
                    taxes_amount,
                    amount,
                    total)
                    
                    SELECT 
                    id,
                    '$tokenForm',                   
                    location_id,
                    id_purchase,
                    id_product,
                    description,
                    description_details,
                    quantity,
                    cost,
                    discount,
                    discount_type,
                    discount_amount,
                    discount_general,
                    discount_general_type,
                    discount_general_amount,
                    taxes,
                    taxes_rate,
                    taxes_amount,
                    amount,
                    total
                    FROM purchase_details 
                    WHERE id_purchase = '$idPurchase'";
        
        $result = $this->query($query);
        if($result){
            return true;
        }
        
        return null;
    }

    public function getById($id, $table = null,$selectAux = null) {
        return parent::getById($id, $this->table,$selectAux);
    }
    
    public function isThereItemsOnPurchase($tokenForm){
        $query = "SELECT count(id) as `rows` FROM ".$this->table." WHERE token_form = '$tokenForm'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $result->fetch_object();
            if($result->rows <= 0){
                return null;
            }
            return true;
        }
        return null;
    }
    
    public function getPurchaseDetails($token_form){
        $login = new Login();
        $query = "SELECT v.*,
                    v.id as idDetailTemp,
                    p.code,
                    fxGetImpuestoName(v.taxes)as taxName,
                    IF(id_product != 0,v.id_product,v.description)as product
                  FROM purchase_details_".$login->getId()." v 
                  LEFT JOIN supplie_and_service p ON v.id_product = p.id
                  WHERE token_form = '$token_form'
                  ORDER BY v.id";
        $result = $this->query($query);
        
        if($result){
            $result = $this->resultToArray($result);
            return $result;
        }
        
        return null;
    }
    
    public function applyGeneralDiscountToItems($options){       
        if($options['subtotal'] <= 0){return true;}
        
        /* Subtotal = importe sin descuentos */
        $discountType = $options['discount_general_type'];
        $discount = $options['discount_general'];
        $subtotal = (float)$options['subtotal'] - (float)$options['discount_items'];
        $tokenForm = $options['token_form'];
        
        if($discountType == 'percent'){$percent = $discount;}
        elseif($discountType == 'amount'){$percent = ($discount*100)/$subtotal;}
        
        $repoProduct = new SupplieAndServiceRepository();         
        $details = $this->getPurchaseDetails($tokenForm);
        
        foreach($details as $detail){            
            $dataTax = $repoProduct->getDataTaxesById($detail['taxes']); 
            $subtotal = ($detail['quantity'] * $detail['cost']) - $detail['discount_amount'];
            $discountAmount = ($subtotal * ($percent/100));
            $subtotal -= $discountAmount;

            $taxes_amount =  round($subtotal * ($dataTax['impuestos_tasa']/100),4,PHP_ROUND_HALF_UP);
            
            $array = array(
                'discount_general_type'=>$discountType,
                'discount_general'=>$discount,
                'discount_general_amount'=>$discountAmount,
                'taxes_amount'=>$taxes_amount,
                'amount'=>$subtotal,
                'total'=>$subtotal + $taxes_amount
            );
            
            parent::update($detail['id'], $array, $this->table);
        }
        
        return true;
    }
}