<?php
class ReportListasRepository extends EntityRepository {    
    public function getInventario(){      
        $repo = new SucursalRepository();
        $sucursales = $repo->getListSucursales('3,6');
        
        $case = '';
        foreach($sucursales as $sucursal){
            $case .= " sum(CASE WHEN id_store = '{$sucursal['id']}' THEN i.stock ELSE 0 END) as '{$sucursal['id']}',"; 
            $case .= " (CASE WHEN id_store = '{$sucursal['id']}' THEN i.notes ELSE '' END) as 'notes_{$sucursal['id']}',"; 
            $arraySucursales[$sucursal['id']] = $sucursal['nombre'];
        }
        
        $case = trim($case,',');
        
        $settings = new SettingsEntity();
        $category_id_for_especiales = $settings->_get('category_id_for_especiales_product');        
        
        $query = "SELECT "
                . "p.id as id_product,"
                . "p.codigo,"
                . "p.descripcion,"
                . "fxGetCategoriaDescripcion(p.categoria)as categoria,"
                . "fxGetMarcaDescripcion(p.marca)as marca,"
                . "i.notes,"
                . "$case "
                . "FROM productos p "
                . "LEFT JOIN inventario i ON p.id = i.id_product "
                . "WHERE type = 'producto'"
                . "AND p.categoria != '$category_id_for_especiales' "
                . "AND p.llevar_inventario = '1' "
                . "GROUP BY p.id";
       // echo $query;exit;
        $result = $this->query($query);
        //exit;
        if($result->num_rows > 0){
           // echo "<pre>";var_dump($this->resultToArray($result));echo "</pre>";exit;
            return array(
                'data'=>$this->resultToArray($result),
                'sucursales'=>$arraySucursales
            );
        }else{
            null;
        }
    }
    
    public function getVentasPorFecha($options){       
        $fecha = null;
        $formaPago = null;
        $store_id = null;
        $status = null;
        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'v.fecha');
        
        if(isset($options['forma_pago'])){
            if(is_array($options['forma_pago']) && count($options['forma_pago']) > 0){
                $formaPagoIds = implode(',', $options['forma_pago']);
                $formaPago = " AND find_in_set(c.formaPago,'$formaPagoIds')";
            }elseif(isset($options['forma_pago']) && trim($options['forma_pago'])!=='' && !is_null($options['forma_pago'])){                
                $formaPago = " AND find_in_set(c.formaPago,'{$options['forma_pago']}') ";
            }           
        }   
        
        if(isset($options['store_id']) && is_array($options['store_id']) && count($options['store_id']) > 0){
            $store_ids = implode(',', $options['store_id']);
            $store_id = " AND find_in_set(idSucursal,'$store_ids')";
        }elseif(isset($options['store_id']) && trim($options['store_id'])!=='' && !is_null($options['store_id'])){
            $store_id = " AND find_in_set(idSucursal,'{$options['store_id']}')";
        }  
  
        if(isset($options['status']) && trim($options['status'])!=='null'){ $status = " AND v.status = '{$options['status']}'";}
        
        $query = "SELECT v.*,"
                . "v.id as idVenta,"
                . "DATE_FORMAT(v.`fecha`,'%m/%d/%Y')as fecha,"
                . "DATE_FORMAT(v.creado_fecha,'%r')as hora,"
                . "fxGetStoreName(idSucursal)as sucursalName,"
                . "ROUND(v.subTotal,2)as subTotal,"
                . "ROUND(SUM(v.descuento_items_monto + v.descuento_orden_monto),2)as descuento,"
                . "ROUND(v.total_impuestos,2)as impuestos,"
                . "fxGetStatusName(v.status,'status','venta')as statusName, "
                . "GROUP_CONCAT(DISTINCT(fxGetFormaPagoName(c.formaPago)))as formaPagoConcat, "
                . "c.formaPago,"
                . "c.monto as monto_con_fp,"
                . "GROUP_CONCAT(DISTINCT(last_4))as last4Concat, "
                . "fxGetUserName(v.creado_por)as usuarioName,"
                . "c.card_fee "
                . "FROM "
                . "cobros c "
                . "left join ventas v on v.id= c.idVenta "
                . "WHERE 1=1 $fecha $formaPago $status $store_id"
                . "GROUP BY c.id ORDER BY creado_fecha DESC";
        $result = $this->query($query);
        //echo $query;exit;
        if($result->num_rows > 0){
            $result = $this->resultToArray($result);
            $ventasPagadas = 0;
            $ventasPagadasMonto = 0;          
            $ventasCanceladas = 0;
            $ventasCanceladasMonto = 0;          
            
            $arrayVentasIds = array();
            $resultFormated = array();
            foreach ($result as $key => $row){
                if(key_exists($row['idVenta'], $arrayVentasIds)){
                    $row['subTotal'] = '';
                    $row['descuento'] = '';
                    $row['impuestos'] = '';
                    $row['total_venta'] = '';
                    $row['statusName'] = '';
                    $row['last4Concat'] = '';
                    $row['usuarioName'] = '';
                }
                $arrayVentasIds[$row['idVenta']] = $row['idVenta'];
                $resultFormated[] = $row;
                
                if($row['status']=='3'){
                    $ventasCanceladas += 1;
                    $ventasCanceladasMonto += round($row['total_venta'],2);
                }elseif($row['status']=='2'){
                    $ventasPagadas += 1;
                    $ventasPagadasMonto += round($row['total_venta'],2);
                }
            }
            
            //echo $ventasPagadasMonto;exit;
            return array(
                'data'=>$resultFormated,
                'ventasPagadas'=>$ventasPagadas,
                'ventasPagadasMonto'=>$ventasPagadasMonto, 
                'ventasCanceladas'=>$ventasCanceladas,
                'ventasCanceladasMonto'=>$ventasCanceladasMonto
            );
            
        }
        return null;        
    }
    
    public function getDevolucionesPorFecha($options){
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'fechaDevolucion');
        $idCaja = null;
        if(key_exists('idCaja', $options)){$idCaja = " AND idCaja = '{$options['idCaja']}'";}
         
         $query = "SELECT idDevolucion,idVenta,SUM(cantidad * devolucion)as total,
                    fxGetStatusName(status,'status','devolucion')as statusName 
                    FROM view_devoluciones
                    WHERE 1=1 $fecha $idCaja
                    GROUP BY idDevolucion";
         
         $result = $this->query($query);
         
         if($result->num_rows > 0){
             $result = $this->resultToArray($result);
             
             return  array('data'=>$result);
         }
         return null;
    }
    
    public function getVentasDetalles($options){
        $status = null;
        $store_id = null;
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'v.fecha');
        
        if(isset($options['store_id']) && is_array($options['store_id']) && count($options['store_id']) > 0){
            $store_ids = implode(',', $options['store_id']);
            $store_id = " AND find_in_set(idSucursal,'$store_ids')";
        }elseif(isset($options['store_id']) && trim($options['store_id'])!=='' && !is_null($options['store_id'])){
            $store_id = " AND find_in_set(idSucursal,'{$options['store_id']}')";
        }    
        
        if(trim($options['status'])!=='null'){$status = " AND v.status = '{$options['status']}'";}
        
        $query = "SELECT vd.*,"
                . "v.status,"
                . "fxGetStatusName(v.status,'status','venta')as statusName, "
                . "DATE_FORMAT(v.`fecha`,'%m/%d/%Y')as fecha,"
                . "DATE_FORMAT(v.creado_fecha,'%r')as hora,"
                . "v.num_venta,"
                . "fxGetStoreName(v.idSucursal)as sucursalName, "
                . "fxGetUserName(v.creado_por)as usuarioName,"
                . "vd.precio_sin_impuestos * vd.cantidad as subTotal,"
                . "vd.descuento_item_monto + vd.descuento_orden_monto as descuento,"
                . "vd.descripcion as desripcion,"
                . "fxGetTamanoDescripcion(p.tamano)as tamano "
                . "FROM ventas v "
                . "LEFT JOIN ventasdetalles vd ON v.id = vd.idVenta "
                . "LEFT JOIN productos p ON vd.idProducto = p.id "
                . "WHERE  1= 1 "
                . "$fecha "
                . "$store_id "
                . "$status "
                . "GROUP BY vd.id ORDER BY v.creado_fecha DESC";
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $this->resultToArray($result);
            $ventasPagadas = array();
            $ventasPagadasMonto = 0;
            $ventasCanceladas = array();
            $ventasCanceladasMonto = 0;
            foreach ($result as $key => $row){
                $total = $row['subTotal'] - $row['descuento'] + $row['impuestos_monto'];              
                $result[$key]['total'] = $total;
                
                if($row['status'] === '2'){
                    $ventasPagadasMonto += $total;
                    $ventasPagadas[$row['idVenta']] = 1;
                }elseif($row['status'] === '3'){
                    $ventasCanceladasMonto += $total;
                    $ventasCanceladas[$row['idVenta']] = 1;
                }
                
            }
            
            return array(
                'data'=>$result,
                'ventasPagadas'=>count($ventasPagadas),
                'ventasPagadasMonto'=>$ventasPagadasMonto,
                'ventasCanceladas'=>count($ventasCanceladas),
                'ventasCanceladasMonto'=>$ventasCanceladasMonto,2
            );
        }
        return null;        
    }
    
    public function getVentasDiarias($options){
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'date(v.creado_fecha)');
        #Obtengo total de ventas agrupado por formaDePago        
        $ventasPorFormaDePago = null;
        $query = "SELECT "
               . "fxGetFormaPagoName(formaPago)as formaPago,"
               . "SUM(c.monto)as total,"
               . "group_concat(DISTINCT(c.idVenta))as idVentas "
               . "FROM cobros c,ventas v "
               . "WHERE c.idVenta = v.id "
               . " $fecha "
               . "AND v.status != 3 "
               . "GROUP BY formaPago ORDER BY formaPago ASC";   
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $ventasPorFormaDePago = $this->resultToArray($result);
        }
        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'date(v.creado_fecha)');
        #Obtener diferentes impuestos en las ventas dentro del rango
        $impuestosList = null;
        $query = "SELECT DISTINCT(impuesto) impuesto,fxGetImpuestoName(impuesto)as impuestoName "
                        . "FROM view_ventas_info_detalles v "
                        . "WHERE 1 = 1 $fecha AND status != 3 "
                        . "GROUP BY impuesto";
         
        $result = $this->query($query);
        if($result->num_rows > 0){
            $impuestosList = $this->resultToArray($result);
            $impuestosListTemp = array();
            foreach ($impuestosList as $impuesto){
                $impuestosListTemp[$impuesto['impuesto']] = $impuesto['impuestoName'];
            }
            $impuestosList = $impuestosListTemp;
        }
      
        if($impuestosList){
            #Asigno porcentaje de impuestos a cada formaDePago      
            if($ventasPorFormaDePago){
                foreach($ventasPorFormaDePago as $key => $formaPago){
                    foreach($impuestosList as $impuesto => $impuestoNombre){
                        $montoImpuesto = 0;
                        $subTotal = 0;
                        $query = "SELECT "
                            . "impuesto,"
                            . "fxGetImpuestoName(impuesto)as impuestoName, "
                            . "SUM(impuestos)as montoImpuesto, "
                            . "SUM(subTotal - (IFNULL(descuento,0) + IFNULL(devoluciones,0)))as subTotal "
                            . "FROM view_ventas_info_detalles v "
                            . "WHERE 1 = 1 $fecha "
                            . "AND status != 3 "
                            . "AND find_in_set(idVenta,'{$formaPago['idVentas']}') "
                            . "AND impuesto = '$impuesto' ";
                            
                        $result = $this->query($query);
                        if($result->num_rows > 0){
                            $result = $result->fetch_object();
                            $montoImpuesto = $result->montoImpuesto;
                            $subTotal = $result->subTotal;
                        }
                        
                        if(isset($ventasPorFormaDePago[$key]['impuestos'][$impuesto])){
                            $ventasPorFormaDePago[$key]['impuestos'][$impuesto]['montoImpuesto'] += $montoImpuesto;
                            $ventasPorFormaDePago[$key]['impuestos'][$impuesto]['subTotal'] += $subTotal;
                        }else{                            
                            $ventasPorFormaDePago[$key]['impuestos'][$impuesto]['nombre'] =  $impuestoNombre;
                            $ventasPorFormaDePago[$key]['impuestos'][$impuesto]['montoImpuesto'] = $montoImpuesto;
                            $ventasPorFormaDePago[$key]['impuestos'][$impuesto]['subTotal'] = $subTotal;
                        }
                    }
                }
            }
        }
        
        return array(
            'ventasPorFormaDePago'=>$ventasPorFormaDePago,
            'listaImpuestos'=>$impuestosList,
            'data'=>$this->getVentasPorFecha($options)
        );      
    }
    
    public function getVentasPorProducto($options){  
        $store_id = null;
        $category_id = null;
        $selectFecha ="DATE_FORMAT(v.`fecha`,'%m/%d/%Y')as fecha,";
        $selectSucursalName = "fxGetStoreName(v.idSucursal) as sucursalName";
        $groupBySucursal = ',v.idSucursal';
        $groupByFecha = ',v.fecha';
        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'date(fecha)'); 
        
        if(isset($options['category_id'])){
            if(is_array($options['category_id']) && count($options['category_id']) > 0){
                $categoryIds = implode(',', $options['category_id']);
                $category_id = " AND find_in_set(p.categoria,'{$categoryIds}')";
            }else{
                if(trim($options['category_id'])!= ''){$category_id = " AND find_in_set(p.categoria,'{$options['category_id']}')";}                     
            }           
        }  

        if(isset($options['store_id']) && $options['store_id'] != ''){
            if(is_array($options['store_id'])){
                 $store_ids = implode(',', $options['store_id']);
            }else{
                 $store_ids = $options['store_id'];
            }           
            
            if($store_ids == 'all'){
                $store_id = "";
                $selectSucursalName = "'Todas' as sucursalName";
                $groupBySucursal = '';
                $groupByFecha = '';
                $selectFecha = "'{$options['fechaInicio']} - {$options['fechaFin']}' as fecha,";
            }else{
                $store_id = " AND find_in_set(idSucursal,'$store_ids') ";
            }             
        }else{          
            $store_id = "";
            $selectSucursalName = "'Todas' as sucursalName";
            $groupBySucursal = '';
            $groupByFecha = '';
            $selectFecha = "'{$options['fechaInicio']} - {$options['fechaFin']}' as fecha,";
        }
        
        
      
        $query = "SELECT "
                . "d.idProducto,"
                . "$selectFecha "
                . "d.descripcion as producto,"
                . "fxGetTamanoDescripcion(p.tamano)as 'tamano',"
                . "SUM(d.cantidad)as cantidad,"
                . "c.descripcion as categoria,"
                . "SUM( ROUND(d.precio_sin_impuestos * d.cantidad,4) - (d.descuento_orden_monto + d.descuento_item_monto) + d.impuestos_monto)as monto,"
                . "$selectSucursalName "
                . "FROM ventas v "
                . "LEFT JOIN ventasdetalles d ON v.id = d.idVenta "
                . "LEFT JOIN  productos p ON d.idProducto = p.id "
                . "LEFT JOIN categorias c ON p.categoria = c.id "
                . "WHERE 1 = 1 $fecha $store_id $category_id "
                . "AND v.status != '3' "
                . "GROUP BY d.idProducto$groupByFecha$groupBySucursal "
                . "ORDER BY FIELD (p.tamano,'10','1','2','3','4','5','6','7','8','9'),p.descripcion ASC, fecha ASC";    
         //echo $query;exit;
        $result = $this->query($query);
         
        if($result->num_rows > 0){
            return array(
                'data'=>$this->resultToArray($result)
            );
        }
       
        return null;
    }
    
    public function getVentasPorProductoEnOrdenesEspeciales($options){
        $store_id = null;       
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'date(v.delivery_date)'); 
        
        if(isset($options['store_id']) && is_array($options['store_id']) && count($options['store_id']) > 0){
            $store_ids = implode(',', $options['store_id']);
            $store_id = " AND find_in_set(v.store,'$store_ids')";
        }elseif(isset($options['store_id']) && trim($options['store_id'])!=='' && !is_null($options['store_id'])){
            $store_id = " AND find_in_set(v.store,'{$options['store_id']}')";
        }  
      
         $query = "SELECT "
                . "d.id_product as idProducto,"
                . "DATE(v.delivery_date) as fecha,"
                . "p.descripcion as producto,"
                . "fxGetTamanoDescripcion(p.tamano)as 'tamano',"
                . "SUM(d.quantity)as cantidad,"
                . "fxGetStoreName(v.store) as sucursalName "
                . "FROM special_requisitions v "
                . "LEFT JOIN special_requisitions_details d ON v.id = d.id_requisition "
                . "LEFT JOIN  productos p ON d.id_product = p.id "
                . "WHERE 1 = 1 $fecha $store_id "
                . "AND d.`type` = 'Line' " 
                . "AND v.status != '3' "
                . "GROUP BY d.id_product,DATE(v.delivery_date) "
                . "ORDER BY v.delivery_date ASC ";  
         
        $result = $this->query($query);
         
        if($result->num_rows > 0){
            return array(
                'data'=>$this->resultToArray($result)
            );
        }
       
        return null;
    }
    
    public function getSaldosPendientes($options = null){
        $date = null;
        $store_id = null;
        $limit = null;

        if($options != null){
            $date = $this->createFilterFecha($options['fechaInicio'],$options['fechaFin'], 'DATE(r.delivery_date)');      
            if(isset($options['store_id']) && is_array($options['store_id']) && count($options['store_id']) > 0){
                $store_ids = implode(',', $options['store_id']);
                $store_id = " AND find_in_set(r.store,'$store_ids')";
            }elseif(isset($options['store_id']) && trim($options['store_id'])!=='' && !is_null($options['store_id'])){
                $store_id = " AND find_in_set(r.store,'{$options['store_id']}')";
            }  
        }else{
          $limit = " LIMIT 150";
        }        

        $query = "SELECT r.req_number as 'Numero de orden',
               DATE_FORMAT(r.date,'%m/%d/%Y')as Fecha,                
               DATE_FORMAT(r.delivery_date,'%m/%d/%Y %h:%i %p')as 'Fecha de entrega',
               fxGetClienteName(r.customer) as Cliente,
               r.ammount as 'Importe factura',
               r.ammount_payments as 'Pagos',
               ROUND((r.ammount - r.ammount_payments), 2) as 'Saldo Pendiente',
                fxGetStatusName(r.`status`,'status','Special-requisition')as Status,
               group_concat(distinct v.id) as ticket
               FROM special_requisitions r
               left join ventas as v on r.id = v.id_special_requisition
               WHERE 1 = 1 
               $date "
             . "$store_id " 
             . "GROUP BY r.id "
             . "ORDER BY r.id asc $limit ";

       $result = $this->query($query);

       if($result->num_rows > 0){
           return $this->resultToArray($result);
       }        
       return null;
}

    public function getInventoryStores(){      
        $repo = new SucursalRepository();
        $sucursales = $repo->getListSucursales();
        
        $case = '';
        foreach($sucursales as $sucursal){            
            if($sucursal['id'] !== '5'){ // 4 es Almacen;
                $case .= " sum(CASE WHEN id_store = '{$sucursal['id']}' THEN i.stock ELSE 0 END) as '{$sucursal['id']}',"; 
                $arraySucursales[$sucursal['id']] = $sucursal['nombre'];
            }        
        }
        
        $case = trim($case,',');
        $query = "SELECT "
                . "i.id_product,"
                . "p.codigo as code,"
                . "p.descripcion as description,"
                . "fxGetTamanoDescripcion(p.tamano)as size,"
                . "$case FROM inventario i LEFT JOIN productos p  ON p.id = i.id_product "
                . "WHERE 1 = '1' "
                . "AND presentacion = 'Si' "
                . "GROUP BY p.id";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return array(
                'data'=>$this->resultToArray($result),
                'sucursales'=>$arraySucursales
            );
        }else{
            null;
        }
    }

    public function getBakedPlan($options){
        $detalles = array();
        $listRequisitions = null;
        $specialDetalles = array();
        $listSpecialRequisitions = null;
        $globalDetalles = null;
        
         if($options['requisitions']){
            $requisition = new RequisitionEntity();
            $idRequisitions = implode(',', $options['requisitions']);
            $detalles = $requisition->getBakedPlan($idRequisitions);
            $listRequisitions = $requisition->getListRequisitionsByIds($idRequisitions);
            
            if($detalles){ 
                $detallesTemp = null;
                foreach($detalles as $detalle){ 
                    $detallesTemp[$detalle['id_slice']] = $detalle;
                    $globalDetalles[$detalle['id_slice']] = $detalle;
                }
                $detalles = $detallesTemp;
            }else{
                $detalles = array();
            }            
        }
        
        if($options['special_requisitions']){
            $specialRequisition = new SpecialRequisitionEntity();
            $idRequisitions = implode(',', $options['special_requisitions']);
            $specialDetalles = $specialRequisition->getBakedPlan($idRequisitions);
            $listSpecialRequisitions = $specialRequisition->getListRequisitionsByIds($idRequisitions);
            
            if($specialDetalles){
                $specialDetallesTemp = null;
                foreach($specialDetalles as $specialDetalle){ 
                    $specialDetallesTemp[$specialDetalle['id_slice']] = $specialDetalle;
                     $globalDetalles[$specialDetalle['id_slice']] = $specialDetalle;
                }
                $specialDetalles = $specialDetallesTemp;
            }else{
                $specialDetalles = array();
            }
        }
        
        return array(
            'globalDetalles'=>$globalDetalles,
            'requisitionsDetalles'=>$detalles,
            'specialRequisitionsDetalles'=>$specialDetalles,
            'listSpecialRequisitions'=>$listSpecialRequisitions
        );
    }
    
    public function getTimeClock($options){     
        $user  = null;
        $date = null;
        $store_id = null;
        $limit = null;        

        if($options != null){         
            $date = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 't.date');
            if(isset($options['store_id']) && is_array($options['store_id']) && count($options['store_id']) > 0){
                $store_ids = implode(',', $options['store_id']);
                $store_id = " AND find_in_set(t.sucursal,'$store_ids')";
            }elseif(isset($options['store_id']) && trim($options['store_id'])!=='' && !is_null($options['store_id'])){
                $store_id = " AND find_in_set(t.sucursal,'{$options['store_id']}')";
            }  
            
            if(isset($options['id_user']) && is_array($options['id_user']) && count($options['id_user']) > 0){
                $userIds = implode(',', $options['id_user']);
                $user = " AND find_in_set(t.id_user,'$userIds')";
            }
            
        }else{
          $limit = " LIMIT 150 ";          
        }        
 
        $select = "SELECT 
                    t.id,
                    t.id_user,
                    date_format(t.date,'%c/%d/%Y')as date,
                    fxGetStoreName(t.sucursal)as sucursalName,
                    date_format(t.check_in,'%r')as check_in,
                    date_format(t.check_out,'%r')as check_out,
                    fxGetUserName(t.id_user)as userName,
                    timediff(t.check_out,t.check_in)as total_work,
                    ROUND(((time_to_sec(timediff(t.check_out,t.check_in)))/60)/60 ,2) as total
                    from timeclock t, usuarios u 
                    WHERE t.id_user = u.id
                    $date $user $store_id
                    ORDER BY u.apellido ASC, u.nombre ASC";
        
        $result = $this->query($select);

        if ($result) {
           $result = $this->resultToArray($result);
           
           $data = null;
           foreach($result as $row){
               $data[$row['id_user']][] = $row;
           }
           
           return array(
               'data'=>$data
           );
        }
        return null;
    }
    
    public function getSalesActivity($options){
        $fecha = null;
        $store_id = null;
        
        $total_sales = 0;
        $quantity_sales = 0;
        $total_discounts = 0;
        $total_sold_products = 0;
        $productosVendidos = array();
        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'v.fecha');
        if(isset($options['store_id'])){$store_id = " AND idSucursal = '{$options['store_id']}'";}
        
        $query = "SELECT "
                . "SUM(total_venta)as total_sales,"
                . "COUNT(id)as quantity_sales,"
                . "SUM(descuento_items_monto+descuento_orden_monto)as total_discounts "
                . "FROM ventas v "
                . "WHERE status != '3' "
                . "$fecha $store_id";
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result  = $result->fetch_object();
            $total_sales = $result->total_sales;
            $quantity_sales = $result->quantity_sales;
            $total_discounts = $result->total_discounts;    
            
            $productosVenta = $this->getVentasPorProducto($options);
            if($productosVenta['data']){
                foreach ($productosVenta['data'] as $producto){
                    $total_sold_products += $producto['cantidad'];
                    if(key_exists($producto['idProducto'], $productosVendidos)){
                        $productosVendidos[$producto['idProducto']]['cantidad'] += $producto['cantidad'];
                    }else{
                        $productosVendidos[$producto['idProducto']] = $producto;
                    }
                }
            }
            
            $productosRequisiciones = $this->getVentasPorProductoEnOrdenesEspeciales($options);
            if($productosRequisiciones){
                foreach ($productosRequisiciones as $producto){                    
                    $total_sold_products += $producto['Cantidad'];
                    if(key_exists($producto['idProducto'], $productosVendidos)){
                         $productosVendidos[$producto['idProducto']]['cantidad'] += $producto['Cantidad'];
                    }else{
                        $producto['cantidad'] = $producto['Cantidad'];
                        $producto['tamano'] = $producto['Tamano'];
                        $producto['producto'] = $producto['Producto'];
                        $productosVendidos[$producto['idProducto']] = $producto;
                    }
                }
            }
            
            $formasPago = array();
            $query = "SELECT "
                . "SUM(c.monto)as monto,"
                . "fxGetFormaPagoName(c.formaPago)as formaPago "
                . "FROM ventas v, cobros c "
                . "WHERE c.idVenta = v.id "
                . "AND c.status != '3' "
                . "$fecha $store_id "
                . "GROUP BY c.formaPago";
            
            $resultFormaPago = $this->query($query);
            if($resultFormaPago->num_rows > 0){
                $formasPago = $this->resultToArray($resultFormaPago);
            }
        }
        
        return array(
            'total_sales'=>$total_sales,
            'quantity_sales'=>$quantity_sales,
            'total_discounts'=>$total_discounts,
            'total_sold_products'=>$total_sold_products,
            'summary_sold_products'=>$productosVendidos,
            'payment_method'=>$formasPago
                
        );
    }
    
    public function getTransactions($options){
        return $this->getVentasPorFecha($options);
    }
    
    public function getMobileTimeClock($options){
        $date = null;
        $store_id = null;
        $limit = null;        
   
        $date = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 't.date');
        if(isset($options['store_id'])){$store_id = " AND t.sucursal = '{$options['store_id']}'";}          
 
        $select = "SELECT 
                    t.id,
                    t.id_user,
                    date_format(t.date,'%c/%d/%Y')as date,
                    fxGetStoreName(t.sucursal)as sucursalName,
                    date_format(t.check_in,'%h:%i%p')as check_in,
                    date_format(t.check_out,'%h:%i%p')as check_out,
                    fxGetUserName(t.id_user)as userName,
                    timediff(t.check_out,t.check_in)as total_work,
                    ((time_to_sec(timediff(t.check_out,t.check_in)))/60)/60 as total
                    from timeclock t, usuarios u 
                    WHERE t.id_user = u.id 
                    $date $store_id
                    ORDER BY u.apellido ASC, u.nombre ASC";
        
        $result = $this->query($select);

        if ($result) {
           $result = $this->resultToArray($result);
           
           return array(
               'data'=>$result
           );
        }
        return null;
    }
    
    public function getHistorialInventario($options){
        $store_id = null;
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'DATE(date)');
        
        if(isset($options['store_id']) && is_array($options['store_id']) && count($options['store_id']) > 0){
            $store_ids = implode(',', $options['store_id']);
            $store_id = " AND find_in_set(id_store,'$store_ids')";
        }elseif(isset($options['store_id']) && trim($options['store_id'])!=='' && !is_null($options['store_id'])){
            $store_id = " AND find_in_set(id_store,'{$options['store_id']}')";
        }         
        
        $query = "SELECT 
                p.descripcion as Producto,
                fxGetTamanoDescripcion(p.tamano)AS 'Tamano',
                h.stock,
                h.date as Fecha,
                h.controller as Operacion
                FROM inventario_historial h, productos p
                WHERE h.id_product = p.id $store_id $fecha";
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result);
        }        
         
        return null;        
    }
    
     public function getSpecialProductionPlan($options){        
        $idsRequisitions = implode(',',$options['special_requisitions']);
        $repoSR = new SpecialRequisitionRepository();
        $requisitionsList = $repoSR->getListRequisitionsByIds($idsRequisitions);
        $requisitionsDetailsList = $repoSR->getSpecialProductionPlan($idsRequisitions);
        
        if($requisitionsList == null){
            return null;
        }
       
        return array(
            'requisitionsList'=>$requisitionsList,
            'requisitionsDetailsList'=>$requisitionsDetailsList
        );
    }
    
    public function getProduction($options){        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'DATE(p.creado_fecha)');
       
        $query = "SELECT pp.codigo as code,"
                . "DATE_FORMAT(p.creado_fecha,'%d/%m/%Y')as createdDateFormated,"
                . "fxGetProductoDescripcion(id_product)as description,"
                . "fxGetSizeDescriptionByIdProduct(id_product)as size, "
                . "SUM(quantity) as quantity "
                . "FROM production p,productos pp "
                . "WHERE pp.id = p.id_product "
                . "$fecha "
                . "GROUP BY p.id_product,pp.tamano";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return array(
                'data'=>$this->resultToArray($result)
            );
        }
        
        return null;
    }
    
     public function getShipmentSpecialOrder($options){
        $date = null;
        $pikup_on = null;
        $status_delivery = null;
        $status_delivery_to_store = null;
        $status_received_on_store = null;
        $limit = null;
        
         if($options){
            $date = $this->createFilterFecha($options['fechaInicio'],$options['fechaFin']   ,"DATE(s.delivery_date)");                
            if(isset($options['pickup_on'])){
                if(is_array($options['pickup_on']) && count($options['pickup_on']) > 0){
                    $pikup_on_ids = implode(',', $options['pickup_on']);
                    $pikup_on = " AND find_in_set(s.pickup_on,'{$pikup_on_ids}')";
                }else{
                    if(trim($options['pickup_on'])!= ''){$pikup_on = " AND find_in_set(s.pickup_on,'{$options['pickup_on']}')";}                     
                }           
            }  
            
            if(isset($options['status_delivery'])){
                if(is_array($options['status_delivery']) && count($options['status_delivery']) > 0){
                    $status_delivery_ids = implode(',', $options['status_delivery']);
                    $status_delivery = " AND find_in_set(s.status_delivery,'{$status_delivery_ids}')";
                }else{
                    if(trim($options['status_delivery'])!= ''){$status_delivery = " AND find_in_set(s.status_delivery,'{$options['status_delivery']}')";}                     
                }           
            }  
            
            if(isset($options['status_delivery_to_store'])){
                if(is_array($options['status_delivery_to_store']) && count($options['status_delivery_to_store']) > 0){
                    $status_delivery_to_store_ids = implode(',', $options['status_delivery_to_store']);
                    $status_delivery_to_store = " AND find_in_set(s.status_delivery_to_store,'{$status_delivery_to_store_ids}')";
                }else{
                    if(trim($options['status_delivery_to_store'])!= ''){$status_delivery_to_store = " AND find_in_set(s.status_delivery_to_store,'{$options['status_delivery_to_store']}')";}                     
                }           
            }  
            
            if(isset($options['status_received_on_store'])){
                if(is_array($options['status_received_on_store']) && count($options['status_received_on_store']) > 0){
                    $status_received_on_store_ids = implode(',', $options['status_received_on_store']);
                    $status_received_on_store = " AND find_in_set(s.status_received_on_store,'{$status_received_on_store_ids}')";
                }else{
                    if(trim($options['status_received_on_store'])!= ''){$status_received_on_store = " AND find_in_set(s.status_received_on_store,'{$options['status_received_on_store']}')";}                     
                }           
            }  
            
            if(is_null($date) 
                    && is_null($pikup_on)
                    && is_null($status_delivery)
                    && is_null($status_delivery_to_store)
                    && is_null($status_received_on_store)
                    ){$limit = " LIMIT 300";}
            
        }else{
            $limit = " LIMIT 300";
        }       
        
       $query = "SELECT s.*,
                fxGetStoreName(store)as storeName,
                fxGetStoreName(pickup_on)as pickup_on_name,
                DATE_FORMAT(s.date,'%m/%d/%Y')as date,                
                DATE_FORMAT(s.delivery_date,'%m/%d/%Y %h:%i %p')as deliveryDate,                                
                fxGetClienteName(s.customer) as customer_name,
                s.phone
                FROM special_requisitions s, special_requisitions_details d
                WHERE s.id = d.id_requisition 
                AND s.status = 1 "
              . "$status_delivery "
              . "$status_delivery_to_store "
              . "$status_received_on_store "              
              . "$date " 
              . "GROUP BY s.id "
              . "ORDER BY s.id DESC $limit ";
    
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return array(
                'data'=>$this->resultToArray($result)
            );
        }        
        
        return null;
    }
    
    public function getSalesByUser($options){
        $date = null;
        $user = null;
        $limit = null;
        
         if($options){
            $date = $this->createFilterFecha($options['fechaInicio'],$options['fechaFin']   ,"DATE(v.fecha)");                
            if(isset($options['id_user'])){
                if(is_array($options['id_user']) && count($options['id_user']) > 0){
                    $user_ids = implode(',', $options['id_user']);
                    $user = " AND find_in_set(v.creado_por,'{$user_ids}')";
                }else{
                    if(trim($options['id_user'])!= ''){$user = " AND find_in_set(v.creado_por,'{$options['id_user']}')";}                     
                }           
            }  
            
            if(is_null($date) 
                    && is_null($user)
                    ){$limit = " LIMIT 300";}
            
        }else{
            $limit = " LIMIT 300";
        }             
        
        $query = "SELECT
                    fxGetUserName(v.creado_por)AS usuario,
                    SUM(d.cantidad)AS cantidad,
                    d.descripcion,
                    fxGetTamanoDescripcion(p.tamano)as tamano
                    FROM ventas v
                    LEFT JOIN ventasdetalles d ON d.idVenta = v.id
                    LEFT JOIN productos p ON d.idProducto = p.id
                    WHERE v.status != 3
                    $date
                    $user
                    GROUP BY v.creado_por,d.idProducto";
        
        $result = $this->query($query);
        if($result->num_rows > 0){
            return array(
                'data'=>$this->resultToArray($result)
            );
        }
    }
    
    public function getProductionAndSale($options){
        $date = null;
        $limit = null;
        
         if($options){
            $ventaDate = $this->createFilterFecha($options['fechaInicio'],$options['fechaFin']   ,"DATE(v.fecha)");                           
            $productionDate = $this->createFilterFecha($options['fechaInicio'],$options['fechaFin']   ,"DATE(pr.creado_fecha)");                           
            
            if(is_null($date)){$limit = " LIMIT 300";}
            
        }else{
            $limit = " LIMIT 300";
        }             
        
        $query = "SELECT 
                    descripcion,
                    tamano,
                    SUM(CASE WHEN operacion = 'venta' THEN cantidad  ELSE 0 END)AS venta,
                    SUM(CASE WHEN operacion = 'produccion' THEN cantidad  ELSE 0 END)AS produccion,
                    ROUND(total,2) AS total_vendido
                    FROM (
			SELECT
			'venta' AS operacion,
			v.fecha,
			SUM(d.cantidad)AS cantidad,
			d.descripcion,
			fxGetTamanoDescripcion(p.tamano)AS tamano,
			SUM((d.precio_sin_impuestos * d.cantidad) - (d.descuento_item_monto + d.descuento_orden_monto) + d.impuestos_monto) as total,
			d.idProducto AS product_id
			FROM ventas v
			LEFT JOIN ventasdetalles d ON d.idVenta = v.id
			LEFT JOIN productos p ON d.idProducto = p.id
			WHERE v.status != 3
			$ventaDate
			GROUP BY d.idProducto
			
			UNION
			
			SELECT
			'produccion' AS operacion,
			DATE(pr.creado_fecha)AS fecha,
			SUM(pr.quantity)AS cantidad,
			p2.descripcion,
			fxGetTamanoDescripcion(p2.tamano)AS tamano,
			0 AS total,
			pr.id_product AS product_id
			FROM production pr
			LEFT JOIN productos p2 ON pr.id_product = p2.id
			WHERE pr.`status` = 1
			$productionDate
			GROUP BY pr.id_product
                    )AS t GROUP BY t.product_id ORDER BY descripcion, tamano";
        
        $result = $this->query($query);
        if($result->num_rows > 0){
            return array(
                'data'=> $this->resultToArray($result)
            );
        }
        
        return null;
    }
    
    public function getSalesOnline($options){
        $formaPago = null;
        $status = null;        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'v.fecha');
        
        if(isset($options['forma_pago']) && is_array($options['forma_pago']) && count($options['forma_pago']) > 0){
            $formaPagoIds = implode(',', $options['forma_pago']);
            $formaPago = " AND find_in_set(c.formaPago,'$formaPagoIds')";
        }   

        if(isset($options['status']) && trim($options['status'])!=='null'){ $status = " AND v.status = '{$options['status']}'";}
        
        $query = "SELECT v.*,"
                . "fxGetStoreName(v.idSucursal)as store_name,"
                . "fxGetStoreName(v.pickup_store)as pickup_store_name,"
                . "DATE_FORMAT(v.pickup_datetime,'%m/%d/%Y')as formated_pickup_datetime, "
                . "fxGetStatusName(v.status_pickup_online,'status_pickup_online','Ventas')as status_pickup_name, "
                . "GROUP_CONCAT(fxGetFormaPagoName(c.formaPago))as payment_method_name, "
                . "GROUP_CONCAT(c.formaPago)as payment_method_id, "
                . "GROUP_CONCAT(c.numDocumento)as reference, "
                . "fxGetStoreName(v.delivery_sale_online_by)as delivery_sale_online_store_name,"
                . "DATE_FORMAT(v.delivery_sale_online_datetime,'%m/%d/%Y %h:%i %p')as delivery_date_formated,"
                . "fxGetUserName(v.delivery_sale_online_by)as delivery_sale_online_by_name "
                . "FROM ventas v "
                . "LEFT JOIN cobros c ON c.idVenta = v.id "
                . "WHERE v.is_sales_online = '1' "
                . "$status "                
                . "$fecha "
                . "$formaPago "
                . "GROUP BY v.id "
                . "ORDER BY v.fecha ASC ";
        
        $result = $this->query($query);
        if($result->num_rows > 0){
            $result = $this->resultToArray($result);
            $ventasPagadas = 0;
            $ventasPagadasMonto = 0;          
            $ventasCanceladas = 0;
            $ventasCanceladasMonto = 0;          

            foreach ($result as $key => $row){                
                if($row['status']=='3'){
                    $ventasCanceladas += 1;
                    $ventasCanceladasMonto += round($row['total_venta'],2);
                }elseif($row['status']=='2'){
                    $ventasPagadas += 1;
                    $ventasPagadasMonto += round($row['total_venta'],2);
                }
            }
            
            return array(
                'data'=>$result,
                'ventasPagadas'=>$ventasPagadas,
                'ventasPagadasMonto'=>$ventasPagadasMonto, 
                'ventasCanceladas'=>$ventasCanceladas,
                'ventasCanceladasMonto'=>$ventasCanceladasMonto
            );
        }
        
        return null;        
    }
    
    public function getSpecialOrderComisions($options){
        $date = null;
        $user = null;
        $limit = null;
        
         if($options){
            $date = $this->createFilterFecha($options['fechaInicio'],$options['fechaFin']   ,"DATE(s.date)");                
            if(isset($options['id_user'])){
                if(is_array($options['id_user']) && count($options['id_user']) > 0){
                    $user_ids = implode(',', $options['id_user']);
                    $user = " AND find_in_set(s.creado_por,'{$user_ids}')";
                }else{
                    if(trim($options['id_user'])!= ''){$user = " AND find_in_set(s.creado_por,'{$options['id_user']}')";}                     
                }           
            }  
            
            if(is_null($date) 
                    && is_null($user)
                    ){$limit = " LIMIT 300";}
            
        }else{
            $limit = " LIMIT 300";
        }             
        
         $query = "SELECT s.req_number,
               DATE_FORMAT(s.date,'%m/%d/%Y')as formated_date,                
               fxGetStoreName(s.store)as store_name,
               fxGetClienteName(s.customer) as customer_name,
               s.ammount as total,
               s.ammount_payments as payments,
               ROUND((s.ammount - s.ammount_payments), 2) as balance,
               s.total_comision,
               fxGetUserName(s.creado_por)as user_name,
               s.creado_por as id_user
               FROM special_requisitions s
               WHERE status != 2 
               $date 
               $user "
             . "GROUP BY s.id "
             . "ORDER BY s.id asc $limit ";
         
        $result = $this->query($query);
        if($result->num_rows > 0){
           $result = $this->resultToArray($result); 
           $data = null;
           
           foreach($result as $row){
               $data[$row['id_user']][] = $row;
           }
        
            return array(
                'data'=> $data
            );
        }
        
        return null;
    }
    
   public function getPurchaseDetails($options){
        $vendor = null;
        $idProduct = null;
        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 's.date');        
        if(isset($options['vendor']) && is_array($options['vendor']) && count($options['vendor']) > 0){
            $vendor_ids = implode(',', $options['vendor']);
            $vendor = " AND find_in_set(s.id_vendor,'$vendor_ids')";
        }elseif(isset($options['vendor']) && trim($options['vendor'])!=='' && !is_null($options['vendor'])){
            $vendor = " AND find_in_set(s.id_vendor,'{$options['vendor']}')";
        }  
        
        if(isset($options['id_supplie']) && is_array($options['id_supplie']) && count($options['id_supplie']) > 0){
            $idProduct_ids = implode(',', $options['id_supplie']);
            $idProduct = " AND find_in_set(sd.id_product,'$idProduct_ids')";
        }elseif(isset($options['id_supplie']) && trim($options['id_supplie'])!=='' && !is_null($options['id_supplie'])){
            $idProduct = " AND find_in_set(sd.id_product,'{$options['id_supplie']}')";
        }  
        
        $query = "SELECT "
                . "s.id as compra,"
                . "DATE_FORMAT(s.date,'%d/%m/%Y')as fecha,"
                . "fxGetVendorName(s.id_vendor)as proveedor, "
                . "p.code as codigo,"
                . "p.description as descripcion,"
                . "fxGetMarcaDescripcion(p.brand_id)as marca,"
                . "fxGetPresentacionDescripcion(p.presentation_id)as presentacion,"
                . "sd.quantity as cantidad,"
                . "sd.cost_without_tax as costo,"
                . "sd.quantity * sd.cost_without_tax as importe,"
                . "sd.discount_amount + sd.discount_general_amount as descuento,"
                . "sd.amount as subtotal,"
                . "sd.taxes_amount as impuestos,"
                . "sd.total as total "
                . "FROM purchases s, purchase_details sd, supplie_and_service p "
                . "WHERE s.id = sd.id_purchase "
                . "AND sd.id_product = p.id "
                . "$fecha $vendor $idProduct "
                . "ORDER BY p.description ASC, date DESC";
        //echo $query;exit;
        $result = $this->query($query);
        if($result->num_rows > 0){
            return array(
                'data'=>$this->resultToArray($result)
            );
        }
        return null;
    }
    
    public function getSupplieOuts(array $options){        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'date');
        $query = "SELECT 
                        DATE_FORMAT(s.date,'%d/%b/%Y') as date,
                        s.id as reference,  
                        p.code,
                        p.description as description,
                        fxGetPresentacionDescripcion(p.presentation_id)as presentation,
                        fxGetMarcaDescripcion(p.brand_id)as brand,
                        fxGetCategoriaDescripcion(p.category_id)as category,
                        FORMAT(d.quantity,2) as quantity,           
                        fxGetLocationDescription(d.location)as location,
                        s.requested_by
                    FROM supplie_outs s 
                    LEFT JOIN supplie_out_details d ON s.id = d.id_supplie_out
                    LEFT JOIN supplie_and_service p ON d.idProduct = p.id 
                    WHERE 1=1
                    AND s.status = 1
                    $fecha
                    ORDER BY s.date ASC,p.description ASC";
        
        //echo $query;exit;       
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result);
        }else{
            return null;
        }
    }
    
    public function getSupplieReturns(array $options){        
        $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'date');
        $query = "SELECT 
                        DATE_FORMAT(s.date,'%d/%b/%Y') as date,
                        s.id as reference,  
                        p.code,
                        p.description as description,
                        fxGetPresentacionDescripcion(p.presentation_id)as presentation,
                        fxGetMarcaDescripcion(p.brand_id)as brand,
                        fxGetCategoriaDescripcion(p.category_id)as category,
                        FORMAT(d.quantity,2) as quantity,           
                        fxGetLocationDescription(d.location)as location,
                         s.returned_by
                    FROM supplie_returns s 
                    LEFT JOIN supplie_returns_details d ON s.id = d.id_return
                    LEFT JOIN supplie_and_service p ON d.idProduct = p.id 
                    WHERE 1=1
                    AND s.status = 1
                    $fecha
                    ORDER BY s.date ASC,p.description ASC";
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result);
        }else{
            return null;
        }
    }
    
    public function getInventorySupplies(){
        $query = "SELECT
                        p.id as id_product,
                        p.code as code,
                        p.description as description,
                        fxGetPresentacionDescripcion(p.presentation_id)as presentation,
                        fxGetMarcaDescripcion(p.brand_id)as brand,
                        fxGetCategoriaDescripcion(p.category_id)as category,
                        fxGetUnidadMedidaDescripcion(p.um_id)as unit_measurement,
                        fxGetSupplieLocationName(i.location)as location,
                        i.location as id_location,
                        i.quantity as stock
                        
                    FROM supplie_and_service p 
                    JOIN inventory_supplies i ON i.idProduct = p.id
                    WHERE p.type = 'insumo'
                    AND quantity > 0
                    ORDER BY p.description ASC";
       
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $inventory_by_location = $this->resultToArray($result);
            
            $query = "SELECT 
                        p.code as code,
                        p.description as description,
                        fxGetPresentacionDescripcion(p.presentation_id)as presentation,
                        fxGetMarcaDescripcion(p.brand_id)as brand,
                        fxGetUnidadMedidaDescripcion(p.um_id)as unit_measurement,
                        p.min_stock as min_stock,
                        SUM(i.quantity) as stock
                        
                    FROM supplie_and_service p 
                    LEFT JOIN inventory_supplies i ON i.idProduct = p.id
                    WHERE p.type = 'insumo'
                    GROUP BY p.id
                    ORDER BY p.description ASC";
            
            $result = $this->query($query);
            $inventory = $this->resultToArray($result);
           
            return array(
                'inventory'=>$inventory,
                'inventory_by_location'=>$inventory_by_location
            );
            
        }else{
            return null;
        }
    }
    
    public function getHistorialInventarioInsumos($options){
        $fecha = $this->createFilterFecha($options['startDate'], $options['endDate'], 'DATE(date)');
        
        $query = "SELECT 
                p.description AS tiem,
                fxGetBrandDescription(p.brand)AS marca,
                h.stock,
                h.date,
                h.controller
                FROM inventario_historial_insumos h,supplies p
                WHERE h.id_product = p.id $fecha";
        
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result);
        }        
         
        return null;        
    }
    
    public function getSummarySales($options){
        $store_id = null;
        $fecha = null;
        
        if($options){
            $fecha = $this->createFilterFecha($options['fechaInicio'], $options['fechaFin'], 'DATE(v.fecha)');
            
             if(isset($options['store_id']) && is_array($options['store_id']) && count($options['store_id']) > 0){
                $store_ids = implode(',', $options['store_id']);
                $store_id = " AND find_in_set(v.idSucursal,'$store_ids')";
            }elseif(isset($options['store_id']) && trim($options['store_id'])!=='' && !is_null($options['store_id'])){
                $store_id = " AND find_in_set(v.idSucursal,'{$options['store_id']}')";
            }  
        } 
        
        /*
        importe = cantidad * precio_sin_impuesto
        descuento = (descuento_items_monto + descuento_orden_monto)
        subotal = importe - descuento        
        */
        $query = "SELECT 
                SUM(ROUND(v.importe,2))as importe,
                SUM(ROUND(v.descuento_items_monto + v.descuento_orden_monto,2))as descuentos,
                SUM(ROUND(v.subTotal,2))as subtotal,
                SUM(ROUND(v.total_impuestos,2))as impuestos,
                SUM(ROUND(v.total_venta,2))as total_venta 
                FROM ventas v
                WHERE status != 3 
                $store_id 
                $fecha";
        
        $resultVentas = $this->query($query);
        
        if($resultVentas->num_rows > 0){
            $resultVentas = $this->resultToArray($resultVentas)[0];          
            
            /*Obtener formas de pago*/
            $query = "SELECT "
                    . "c.formaPago,"
                    . "f.descripcion as forma_pago,"
                    . "SUM(ROUND(c.monto,2))as total_cobro,"
                    . "SUM(ROUND(v.total_venta,2))as total_venta,"
                    . "SUM(ROUND(c.card_fee,2))as comision_tarjeta "
                    . "FROM cobros c "
                    . "LEFT JOIN ventas v on c.idVenta = v.id "
                    . "LEFT JOIN formas_metodos_pago f ON c.formaPago = f.id "
                    . "WHERE v.status != 3"
                    . "$store_id "
                    . "$fecha "
                    . "GROUP BY c.formaPago";
            //echo $query;
             $resultCobros = $this->query($query);
        
            $formasPago = null;
            if($resultCobros->num_rows > 0){
                $formasPago = $this->resultToArray($resultCobros);
            }
        
            return array(
                'data_ventas'=>$resultVentas,
                'data_cobros'=>$formasPago
            );
        }
        
        return null;
    }
    
    public function createFilterFecha($fechaInicio,$fechaFin,$campoFecha = null ){
        $fecha = null;
        $tools = new Tools();
        if($fechaInicio!=null){
            $fechaInicio = $tools->setFormatDateToDB($fechaInicio);
            if($fechaFin!=null){
                $fechaFin = $tools->setFormatDateToDB($fechaFin);
                $fecha .=" AND $campoFecha BETWEEN '{$fechaInicio}' AND '{$fechaFin}' ";
            }else{
                $fecha .=" AND $campoFecha BETWEEN '{$fechaInicio}' AND '{$fechaInicio}' ";
            }
        }elseif($fechaFin!=null){
            $fecha .=" AND $campoFecha BETWEEN '{$fechaFin}' AND '{$fechaFin}' ";
        }
        
        return $fecha;
    }  
}