<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

    class SupplieAndServiceRepository extends EntityRepository {

    private $table = 'supplie_and_service';
    private $options = array(
        'code' => null,
        'type'=>null,
        'ledger_account'=>null,
        'description' => null,
        'category_id'=>null,
        'brand_id'=>null,
        'presentation_id'=>null,
        'um_id'=>null,
        'cost'=>null,       
        'taxes'=>null,        
        'taxes_included'=>null,        
        'llevar_inventario'=>null,
        'min_stock'=>null,
        'status'=>null,
        'comments'=>null
    );
    
    public function setOptions($data){
        foreach ($this->options as $option => $value){
            if(isset($data[$option])){
              $this->options[$option] = $data[$option];
            }
        }
    }
  
    public function getOptions(){
        return $this->options;
    }
    
    public function getTable(){
        return $this->table;
    }

    public function save(array $data, $table = null) {
        if(trim($data['code'])== ''){$data['code'] = '0';} 
        if(is_null($data['status'])){$data['status'] = '1';}  
        
        return parent::save($data, $this->table);
    }    

    public function update($id, $data, $table = null) {      
        if(trim($data['code'])== ''){$data['code'] = '0';} 
      
        return parent::update($id, $data, $this->table);
    }    
        
    public function delete($id, $table = null) {
        return parent::delete($id, $this->table);
    }    

    public function getById($id, $table = null,$selectAux = null) {
        return parent::getById($id, $this->table,$selectAux);
    }

    public function isUsedInRecord($id, array $buscarEn = null,$andWhere = null) {
       return parent::isUsedInRecord($id, array(
           'purchase_details' => 'id_product'));
    }    
    
    public function getProductsByIds($ids){
        $select = "SELECT * FROM $this->table WHERE id IN($ids)";
        $result = $this->query($select);
        
        if($result){
            return $this->resultToArray($result);
        }
        
        return null;
    }
    
    public function getListSelectProducts($type = null) {       
        if($type !== null){$type = " AND c.type = '$type'";}
        $select = "SELECT p.* "
                . "FROM $this->table p "
                . "LEFT JOIN categorias c ON p.category_id = c.id "
                . "WHERE 1 = 1 $type";
        $result = $this->query($select);

        if ($result) {
            $array = array();
            while ($row = $result->fetch_assoc()) {
                $array[$row['id']] = $row['description'];
            }
            return $array;
        }
        return null;
    }
    
     public function getListProducts() {
        $select = "SELECT g.*,"
                . "fxGetStatusName(g.status,'status','SupplieAndService') as status_name,"
                . "c.descripcion as category_name,"
                . "m.descripcion as brand_name "
                . "FROM $this->table g "
                . "LEFT JOIN categorias c ON g.category_id = c.id "
                . "LEFT JOIN marcas m ON g.brand_id = m.id "
                . "WHERE 1 = 1 ";
        
        $result = $this->query($select);

        if ($result) {
           return $this->resultToArray($result);
        }
        return null;
    }
    
     public function getListStatus(){
        $query = "SELECT * FROM codigo_status WHERE tipo = 'SupplieAndService' ORDER BY codigo ASC";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $array = array();
            foreach($result as $status){
                $array[$status['codigo']] = $status['descripcion'];
            }
            return $array;
        }
        return null;
    }
    
    public function existeCodigo($codigo,$idProduct = null){
        $codigo = strtolower(trim($codigo));
        if($codigo == ''){return null;}else{$codigo = " code = '$codigo' ";}
        
        if($idProduct != null && trim($idProduct)!=''){$idProduct = " AND id != '$idProduct' ";}
        
        $query = "SELECT code,
                         description
                    FROM $this->table 
                    WHERE $codigo $idProduct
                    LIMIT 1 ";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result =  $this->resultToArray($result);
            return $result[0];
        }
        return null;
    }
    
    public function getProductsLike($item){
        $query = "SELECT * FROM $this->table WHERE code like '%$item%' OR description like '%$item%' AND status = 1 ORDER BY description";
        $result = $this->query($query);
        
        if($result){
            return $this->resultToArray($result);
        }
        
        return null;
    }
    
    public function getListaSelectImpuestos() {
        $select = "SELECT * FROM impuestos ORDER BY impuestos_tasa ASC ";
        $result = $this->query($select);

        if ($result) {
            $array = array();
            while ($row = $result->fetch_assoc()) {
                $array[$row['id']] = $row['impuesto'];
            }
            return $array;
        }
        return null;
    }
    
    public function getDataTaxesById($id){
        $query = "SELECT * FROM impuestos WHERE id = '$id'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return $this->resultToArray($result)[0];
        }
        
        return null;
    }
      
  public function getByCode($code) {
        $query = "SELECT * FROM $this->table WHERE code = '$code' LIMIT 1";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $this->resultToArray($result);
            return $result[0];
        }
        return null;
    }
}