<?php
class SupplieReturnDetailsTempRepository extends EntityRepository {

    private $table = 'supplie_returns_details_';
    
    public function __construct(){
        $login = new Login();
        $this->table = $this->table.$login->getId();
    }
    // Guarda en temporal
    public function save(array $data, $table = null) {        
        if(isset($data['idDetailTemp']) && trim($data['idDetailTemp'])!= ''){
            $result = $this->getById($data['idDetailTemp']);
            if($result){
                $id = $data['idDetailTemp'];
                unset($data['idDetailTemp']);    
                return $this->update($id,$data,$this->table);
            }
         }
        
        unset($data['idDetailTemp']);           
        $query = "SELECT id,quantity FROM ".$this->table.
                " WHERE idProduct = '".$data['idProduct']."'".
                " AND location = '".$data['location']."'";
        
        $result = $this->query($query);       

        if($result->num_rows > 0){
            $result = $result->fetch_object();
            $data['quantity'] = $data['quantity'] + $result->quantity;
            $id = $result->id;
            return parent::update($id, $data,$this->table);
        }else{
            return parent::save($data, $this->table);
        }
    }
    
    // Guarda en tabla return_details
    public function saveDetalles($idReturn){
        $query = "SELECT * FROM $this->table";
        $result = $this->query($query);
        if($result->num_rows > 0){           
            $result = $this->resultToArray($result);
            $repoInventorySupplie = new InventorySupplieRepository();
            
            foreach($result as $data){
                unset($data['id']);
                unset($data['id_detail']); 
                $data['id_return'] = $idReturn;
                
                if(parent::save($data, 'supplie_returns_details')){
                    $data['controller'] = "Retorno - Insertar {$idReturn}";
                    if(!$repoInventorySupplie->addInventory($data)){
                        return null;
                    }
                }
            }            
        }
        return true;
    } 
    
    public function updateDetalles($idReturn){
        $repoInventorySupplie = new InventorySupplieRepository();
        $query = "SELECT id,idProduct,location FROM supplie_returns_details WHERE id_return = '$idReturn'";
        $result = $this->query($query);
        $detallesOrigin = null;    
        if($result->num_rows > 0){
            $detallesOrigin = $this->resultToArray($result);
        }
        
        $query = "SELECT * FROM $this->table";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $idsDetalles = array();
        
            $result = $this->resultToArray($result);
            $repoReturn = new SupplieReturnRepository();
            foreach($result as $data){
                $idDetalle = $data['id_detail'];                
                $data['id_return'] = $idReturn;
                unset($data['id']);
                unset($data['id_detail']);                  
              
                if(!$idDetalle){
                    if(parent::save($data, 'supplie_returns_details')){
                        $data['controller'] = "Retorno - Editar {$idReturn}";
                        if(!$repoInventorySupplie->addInventory($data)){
                            return null;
                        }                    
                    }else{
                        return null;
                    }     
                }else{                    
                    #contiene los idDetalles de la salida original que se mantendran, lo que no esten aqui se eliminaran.
                    $idsDetalles[] = $idDetalle;
                    $currenData = $repoReturn->getReturnDetailSaved($idDetalle);
                    if(parent::update($idDetalle,$data, 'supplie_returns_details')){
                        $data['current_quantity'] = $currenData['quantity'];
                        $data['current_location'] = $currenData['location'];
                        $data['controller'] = "Retorno - Editar {$idReturn}";
                        
                        if(!$repoInventorySupplie->editInventory($data)){
                            return null;
                        }                    
                    }else{
                        return null;
                    }
                }  
            }
        }

        #Se eliminan ids de tabla returns_details que ya no estan en $idsDetalles (este array contiene los ids que permanececieron en la compra despues del update)                
        if($detallesOrigin){
            foreach ($detallesOrigin as $detalle){
                if(!in_array($detalle['id'], $idsDetalles)){
                    if(parent::delete($detalle['id'], 'supplie_returns_details')){
                        $detalle['controller'] = "Retorno - Editar {$idReturn}";
                        $repoInventorySupplie->subInventory($detalle);
                    }
                }
            }
        }  
        return true;
    }
    
    public function delete($id, $table = null) {
        return parent::delete($id, $this->table);
    }
    
    public function truncateIfIsEditInfo(){
        $query = "SELECT id_return FROM .".$this->table." LIMIT 1";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $result->fetch_object();
            if($result->id_return !=NULL || $result->id_return != ''){
                $this->truncate();
                return true;
            }
        }        
        return null;
    }
    
    public function truncate(){
        $query = "TRUNCATE ".$this->table;
        $result = $this->query($query);
        
        if($result){
            return true;
        }        
        return null;
    }
    
    public function drop(){
        $query = "DROP TABLE ".$this->table;
        $result = $this->query($query);
        
        if($result){
            return true;
        }        
        return null;
    }
    
    public function setReturnDetailsById($idReturn){
        $this->query("TRUNCATE ".$this->table);
        $query = "INSERT INTO ".$this->table." (id_detail,id_return,idProduct,quantity,location)
                    SELECT id,id_return,idProduct,quantity,location
                    FROM supplie_returns_details 
                    WHERE id_return = '$idReturn'";
        
        $result = $this->query($query);
        if($result){
            return true;
        }        
        return null;
    }

    public function getById($id, $table = null,$selectAux = null) {
        return parent::getById($id, $this->table,$selectAux);
    }
}