<?php
class VentaDetallesTempRepository extends EntityRepository {

    private $table = 'ventasdetalles_';    
    public $flashmessenger = null;
    private $options = array(        
    );
    
    public function __construct(){
        $login = new Login();
        $this->table = $this->table.$login->getId();
        
         if(!$this->flashmessenger instanceof FlashMessenger){
            $this->flashmessenger = new FlashMessenger();
        }
    }
    // Guarda en temporal
    public function save(array $data, $table = null) {        
        if(isset($data['idDetalleTemp']) && trim($data['idDetalleTemp'])!= ''){
            $result = $this->getById($data['idDetalleTemp']);
            if($result){
                $id = $data['idDetalleTemp'];
                unset($data['idDetalleTemp']);      
                return $this->updateDetalleTemp($id, $data);
            }
         }
        
        unset($data['idDetalleTemp']);
        $data['status'] = '1';
        $query = "SELECT id,cantidad FROM ".$this->table.
                 " WHERE idProducto = ".$data['idProducto'].
                 " AND precio = '".$data['precio']."'";
        
        $result = $this->query($query);
        if($result->num_rows > 0 && GROUP_ITEMS_ON_SALE === true){
            $result = $result->fetch_object();
            $data['cantidad'] = $data['cantidad'] + $result->cantidad;
            $id = $result->id;
            
            return $this->updateDetalleTemp($id, $data);
        }else{
            return $this->saveDetalleTemp($data);
        }
    }
    
    public function saveDetalleTemp($data){ 
        #Variables que pueden venir vacias, pero necesitan ser enteros
        if($data['descuento_item_valor']== ''){$data['descuento_item_valor'] = 0;}
        if($data['descuento_orden_valor']== ''){$data['descuento_orden_valor'] = 0;}
        
        #Informacion de impuestos que aplica a producto
        $repoImpuestos = new ImpuestosRepository();
        $dataImpuestos = $repoImpuestos->getById($data['impuestos']);
        $data['impuestos_tasa'] = $dataImpuestos['impuestos_tasa'];
        
        #Precio sin impuestos de producto
        $precioSinImpuestos = $data['precio'];
        $data['precio_sin_impuestos'] =  $precioSinImpuestos;
        
        if($data['impuestos_incluidos'] == 'si'){
            $precioSinImpuestos = round($data['precio']/(1+$dataImpuestos['impuestos_tasa']/100),2); 
            $data['precio_sin_impuestos'] =  round($precioSinImpuestos,2);
        }        
        
        #Descuento por Item y Descuento de Orden        
        #Descuento por item
        $descuentoItem = 0;
        if($data['descuento_item_tipo'] == 'porcentaje' && $data['descuento_item_valor'] !== '0'){
            $descuentoItem = round($precioSinImpuestos * ($data['descuento_item_valor']/100),2);      
            
        }elseif($data['descuento_item_tipo'] == 'monto' && $data['descuento_item_valor'] !== '0'){
            $descuentoItem = $data['descuento_item_valor'];
        }
        
        $precioSinImpuestos -= $descuentoItem;
        $data['descuento_item_monto'] = round($descuentoItem * $data['cantidad'],2);       
        
        #Descuento po orden, solo se aplica si es porcentaje
        $descuentoOrden = 0;
        $data['descuento_orden_monto'] = 0;
        
        if($data['descuento_orden_tipo'] == 'porcentaje' && $data['descuento_orden_valor'] !== '0'){
            $descuentoOrden = round($precioSinImpuestos * ($data['descuento_orden_valor']/100),2);
            $precioSinImpuestos -= $descuentoOrden;
            $data['descuento_orden_monto'] = round($descuentoOrden * $data['cantidad'],2);             
        }   
        
        #subtotal para calcular impuestos
        $precioSinImpuestos = round($precioSinImpuestos * $data['cantidad'],2); 
        
        #Calculo de Impuestos
        $data['impuestos_monto'] = round( ($precioSinImpuestos) * ($dataImpuestos['impuestos_tasa']/100) ,2);      
        
        unset($data['id'],$data['descuento_orden_tipo'],$data['descuento_orden_valor']);
        parent::save($data, $this->table);                
    }
    
    public function updateDetalleTemp($id,$data){   
        #Variables que pueden venir vacias, pero necesitan ser enteros
        if($data['descuento_orden_valor']== ''){$data['descuento_orden_valor'] = 0;}
        if($data['descuento_item_valor']== ''){$data['descuento_item_valor'] = 0;}
        
        #Informacion de impuestos que aplica a producto
        $repoImpuestos = new ImpuestosRepository();
        $dataImpuestos = $repoImpuestos->getById($data['impuestos']);
        $data['impuestos_tasa'] = $dataImpuestos['impuestos_tasa'];
        
        #Precio sin impuestos de producto
        $precioSinImpuestos = $data['precio'];
        $data['precio_sin_impuestos'] =  $precioSinImpuestos;
        
        if($data['impuestos_incluidos'] == 'si'){
            $precioSinImpuestos = round($data['precio']/(1+$dataImpuestos['impuestos_tasa']/100),2); 
            $data['precio_sin_impuestos'] =  round($precioSinImpuestos,2);
        }        
        
        #Descuento por Item y Descuento de Orden
        #Descuento por item
        $descuentoItem = 0;      
        $msgForDiscount = null;
        if($data['descuento_item_valor'] !== '0'){
            if(is_null($this->existAppliedPromocion())){
                 if($data['descuento_item_tipo'] == 'porcentaje'){
                    $descuentoItem = round($precioSinImpuestos * ($data['descuento_item_valor']/100),2);  
                }elseif($data['descuento_item_tipo'] == 'monto'){
                    $descuentoItem = $data['descuento_item_valor'];
                }
            }else{
                $data['descuento_item_valor'] = 0;
                $msgForDiscount = true;
                $this->flashmessenger->addMessage(array('danger'=>'No puede aplicar descuentos, porque la venta ya tiene una promocion aplicada.'));
            }           
        }        
        
        $precioSinImpuestos -= $descuentoItem;
        $data['descuento_item_monto'] = $descuentoItem * $data['cantidad'];          
        
        #Descuento por orden, solo se aplica si es porcentaje
        $descuentoOrden = 0;       
        if($data['descuento_orden_tipo'] == 'porcentaje' && $data['descuento_orden_valor'] !== '0'){
            if(is_null($this->existAppliedPromocion())){
                $descuentoOrden = round($precioSinImpuestos * ($data['descuento_orden_valor']/100),2);
                $precioSinImpuestos -= $descuentoOrden;
                $data['descuento_orden_monto'] = round($descuentoOrden * $data['cantidad'],2);   
            }else{
                $data['descuento_orden_valor'] = 0;
                if(is_null($msgForDiscount)){
                    $this->flashmessenger->addMessage(array('danger'=>'No puede aplicar descuentos, porque la venta ya tiene una promocion aplicada.'));
                }                
            }  
        }   
        
        #subtotal para calcular impuestos
        $precioSinImpuestos = round($precioSinImpuestos * $data['cantidad'],2);
        
        #Calculo de Impuestos
        $data['impuestos_monto'] = round( ($precioSinImpuestos) * ($dataImpuestos['impuestos_tasa']/100),2); 
       
        unset($data['id'],$data['idVenta'],$data['descuento_orden_tipo'],$data['descuento_orden_valor']); 
        parent::update($id,$data, $this->table);    
    }
    
    public function setDescuentoOrden($options){        
        $query = "SELECT * FROM $this->table WHERE status = '1' ";
        $result = $this->query($query);
        if($result->num_rows > 0){           
            $result = $this->resultToArray($result);
            foreach($result as $data){
                $data['descuento_orden_tipo'] = 'porcentaje';
                $data['descuento_orden_valor'] = $options['descuento_orden_valor'];
                $this->updateDetalleTemp($data['id'], $data);
            }
        }
    }
    
    public function getPorcentajeDescuentoDandoMonto($monto){
        $query = "SELECT IFNULL(SUM(precio_sin_impuestos - descuento_item_monto),0)as subtotal"
                . " FROM $this->table WHERE status = '1'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $result->fetch_object();
            $subtotal = $result->subtotal;
            
            $porcentaje = ($monto * 100)/$subtotal;
            return $porcentaje;
        }
    }
    
    // Guarda en tabla ventasdetalles
    public function saveDetalles($idVenta,$ticket){
        $login = new Login();
        $fecha= date('Y-m-d H:i:s');
        
        $query = "SELECT * FROM $this->table WHERE status = '1' ";
        $result = $this->query($query);
        if($result->num_rows > 0){           
            $result = $this->resultToArray($result);             
            
            $repoInventario = new InventarioRepository();        
            $repoVenta = new VentaRepository();
            
            $sucursalId = $login->getSucursal();
            $ventaData = $repoVenta->getById($idVenta);
            
            /*Si la caja es tipo '2 - En linea', el inventario se descuenta de la sucursaal seleccionada como 'Entregar en'*/
            if($_SESSION['usuario']['tipoEstacion'] == '2'){
                $sucursalId = $ventaData['pickup_store'];
            }
           
            foreach($result as $data){   
                unset($data['id']);                
                $data['idVenta'] = $idVenta;   
                $data['ticket'] = $ticket;
                $data['creado_por'] = $login->getId();
                $data['creado_fecha'] = $fecha;
                
                if(parent::save($data, 'ventasdetalles')){                   
                    if(!$repoInventario->subInventory(array(
                        'id_product'=>$data['idProducto'],
                        'quantity'=>$data['cantidad'],
                        'sucursal'=>$sucursalId,
                        'controller'=>'Venta-agregar '.$idVenta))){
                        return null;
                    }
                }else{
                    return null;
                }
            }             
        }    
        return true;
    } 
    
    public function saveDetallesVentaSuspendida($idVentaSuspendida){     
        $query ="UPDATE $this->table SET status = '2',idVenta = '$idVentaSuspendida' WHERE status = '1'";
        $result = $this->query($query);
        
        if($result){
            return $result;
        }
        
        return null;
    }
    
    public function activarVentaSuspendida($idVentaSuspendida){
        $this->clearDetalles();
        $query = "UPDATE $this->table SET status = '1' WHERE idVenta = '$idVentaSuspendida' AND status = '2'";
        $result = $this->query($query);
        
        if($result){
            return true;
        }
        return null;
    }
    
    public function delete($id, $table = null) {        
        return parent::delete($id, $this->table);
    }
    
    public function isThereItemsOnSale(){
        $query = "SELECT count(id) as `rows` FROM ".$this->table." WHERE status = '1'";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $result->fetch_object();
            if($result->rows <= 0){
                return null;
            }
            return true;
        }
        return null;
    }
    
    public function truncateIfIsEditInfo(){
        $query = "SELECT idVenta FROM .".$this->table." LIMIT 1";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $result->fetch_object();
            if($result->idVenta !=NULL || $result->idVenta != ''){
                $this->truncate();
                return true;
            }
        }        
        return null;
    }
    
    public function clearDetalles(){
        $query = "DELETE FROM $this->table WHERE status != '2'";
        $result = $this->query($query);
        
        if($result){
            return true;
        }        
        return null;
    }
    
    public function truncate(){
        $query = "TRUNCATE ".$this->table;
        $result = $this->query($query);
        
        if($result){
            return true;
        }
        
        return null;
    }
    
    public function drop(){
        $query = "DROP TABLE ".$this->table;
        $result = $this->query($query);
        
        if($result){
            return true;
        }
        
        return null;
    }
    
    public function setVentaDetallesById($idVenta){
        $this->query("TRUNCATE ".$this->table);
        $query = "INSERT INTO ".$this->table." (idVenta,idProducto,cantidad,descripcion,precio,immpuestos,descuento,cuentaContable)
                    SELECT idVenta,idProducto,cantidad,descripcion,precio,impuetos,descuento,cuentaContable FROM ventasdetalles WHERE idVenta = '$idVenta'";
        
        $result = $this->query($query);
        if($result){
            return true;
        }        
        return null;
    }

    public function getById($id, $table = null,$selectAux = null) {
        return parent::getById($id, $this->table,$selectAux);
    }    

    public function isUsedInRecord($id, array $buscarEn = null,$andWhere = null) {
        return parent::isUsedInRecord($id, array('pfa' => 'usuario'));
    }
    
    public function getTotalesVenta(){
        $query = "SELECT "
                . "ROUND(SUM(precio_sin_impuestos * cantidad),2)as importe,"
                . "ROUND(SUM(descuento_item_monto),2)as descuento_items_monto,"
                . "ROUND(SUM(descuento_orden_monto),2)as descuento_orden_monto,"
                . "ROUND(SUM((precio_sin_impuestos * cantidad) - (descuento_item_monto + descuento_orden_monto)),2)as subtotal,"
                . "ROUND(SUM(impuestos_monto),2)as total_impuestos,"
                . "ROUND(SUM((precio_sin_impuestos * cantidad) - (descuento_item_monto + descuento_orden_monto) + impuestos_monto),2) as total_venta "
                . "FROM $this->table "
                . "WHERE status = '1' "
                . "GROUP BY idVenta";
        
        $result = $this->query($query);
        
        if($result->num_rows >0){
            return $this->resultToArray($result)[0];
        }        
        
        return null;
    }
    
    public function getTotalPromocionesAplicadas(){
        $query = "SELECT GROUP_CONCAT(p.code)as promotions_code, SUM(v.precio)as promotions_amount "
                . "FROM $this->table v "
                . "LEFT JOIN promotions p ON v.promotion_id = p.id "
                . "WHERE promotion_id is not null AND promotion_id > 0";
        
        $result = $this->query($query);
        
        $data = array('promotions_code'=>'','promotions_amount'=>0);
        if($result->num_rows > 0){
            $data = $this->resultToArray($result)[0];
        }
        
        return $data;
    }
    
    public function deleteVentaSuspendida($idVentaSuspendida){
        $this->startTransaction();
        $query = "DELETE FROM $this->table WHERE idVenta = '$idVentaSuspendida' AND status = '2'";
        $result = $this->query($query);
        
        if($result){
            if(parent::delete($idVentaSuspendida, 'ventas_suspendidas')){
                $this->commit();
                return true;
            }
        }        
        $this->rollback();
        return null;
    }
    
    public function existAppliedPromocion($promotion_id = null){
        /*Cuando se recibe promotion_id es porque se esta buscando una promocion en especifico
          Sino se recibe, es porque se quiere saber si existe cualquier promocion aplicada  */
        if($promotion_id){$promotion_id = " AND promotion_id = '$promotion_id'";}
        $query = "SELECT id FROM $this->table WHERE promotion_id !=0 $promotion_id";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            return true;
        }
        return null;
    }
    
    public function existAppliedDiscount(){
        $query = "SELECT SUM(IFNULL(descuento_item_monto,0) + IFNULL(descuento_orden_monto,0))as discount "
                . "FROM $this->table ";
        $result = $this->query($query);
        
        if($result->num_rows > 0){
            $result = $result->fetch_object();
           
            if(is_null($result->discount) || $result->discount == 0){
                return null;
            }          
        }    
        
         return true;
    }
    
    public function getTableName(){
        return $this->table;
    }
}