<?php
/**
 * Description of LoginForm
 * @author carlos augusto vazquez lara
 */
class AccountingReportForm extends Form {
    public function __construct() {
        $this->setActionForm('Accounting-reports.php');
        $this->setActionController('create');
        $this->setName('reports');
        $this->setMethod('post');
        $this->setClass('form-horizontal');
        parent::__construct();
        $this->init();
        
    }

    public function init() {
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'report',
            'required'=>true
        ));   
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'output',
            'label'=>'Bajar reporte',
            'required'=> true
        ));  
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'optionsFromGet',
            'required'=>true
        ));   
        
        $attributes_wrapper_append_date = array('class'=>'date','id'=>'fechaDatePicker');
        $append = "<span class = 'btn input-group-addon'><i class='fa fa-calendar'></i></span>";
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'startDate',
            'label'=>'Fecha inicio',
            'required'=>false,
            'append'=>$append,
            'wrapper_attributes'=>$attributes_wrapper_append_date
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'endDate',
            'label'=>'Fecha fin',
            'required'=>false,
            'append'=>$append,
            'wrapper_attributes'=>$attributes_wrapper_append_date
        ));
        
        $this->addElement(array(
            'type'=>'submit',
            'name'=>'enviar',
            'value'=>'Enviar',
            'class'=>'btn btn-lg btn-primary'
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'to',
            'label'=>'Para',
            'optionals'=>array('style'=>'width:350px;')
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'cc',
            'label'=>'Copia',
            'optionals'=>array('style'=>'width:350px;')
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'subject',
            'label'=>'Titulo',
            'optionals'=>array('style'=>'width:350px;')
        ));
        
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'message',
            'label'=>'Mensaje',
            'optionals'=>array('style'=>'width:350px;height:100px')
        ));
        
        $this->addElement(array(
            'type' => 'select multiple',
            'name' => 'vendor',
            'label'=>'Proveedor',
            'multiOptions'=>$this->getListProveedores(),
            'required'=>true
        ));    
        
        $this->addElement(array(
            'type'=>'button',
            'name'=>'sendMail',
            'label'=>'',
            'value'=>$this->_getTranslation('Enviar mail'),
            'class'=>'btn btn-primary',
            'optionals'=>array('onclick'=>'sendReportToMail()')
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cerrar',
            'value'=> $this->_getTranslation('Cerrar'),
            'class'=>'btn btn-default btn-lg',
            'optionals'=>array(
                'data-dismiss'=>'modal',
                'aria-hidden'=>'true',
                ),
            'col-size-element'=>'12',
        ));
    }
    
    public function getListProductos(){
        $repoProducts = new SupplieRepository();
        $result = $repoProducts->getListSelectSupplies();
        
        $array = array(''=>'Seleccionar una opcion...');
        if ($result) {               
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
        }
        return $array;
    }
    
     public function getListProveedores(){
        $repoProducts = new VendorRepository();
        $result = $repoProducts->getListSelectVendors();
        
        $array = array(''=>'Seleccionar una opcion...');
        if ($result) {               
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
        }
        return $array;
    }
    
     public function getStringFiltersForm($report){
        $formString = '';
        switch($report){                                   
            case 'vendor_statement': 
                
                $this->setPropiedad('output', array('multiOptions'=>array('pdf'=>'Pdf')));
                
                $formString .= utf8_decode($this->getElementString('vendor'));
                $formString .= $this->getElementString('startDate');
                $formString .= $this->getElementString('endDate');       
                $formString .= $this->getElementString('output');       
                
                break;
            
            case 'inventory_cost': 
                
                $this->setPropiedad('output', array('multiOptions'=>array('excel'=>'Excel')));
                $this->setPropiedad('startDate', array('label'=>'Mes'));
                $formString .= $this->getElementString('startDate');   
                $formString .= $this->getElementString('output');       
                
                break;
        }
        
        return $formString;
    }
}