<?php
/**
 * Description of NivelForm
 *
 * @author carlos
 */

class AppointmentForm extends Form {

    public function __construct() {
        $this->setActionForm('Appointment.php');
        $this->setName('appointment');
        $this->setClass('appointment form-horizontal');
        $this->setMethod('post');
        parent::__construct();
        $this->init();
    }

    public function init() {
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'appointment_num'
        ));
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'sales_person_id'
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'appointment_date',
            'label'=>'Fecha de cita',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'appointment_hour',
            'label'=>'Hora de cita',
            'multiOptions'=>array(''=>'Seleccionar una opcion'),
            'required'=> true
        ));
        
        $append = "<span class = 'btn input-group-addon _setModalClienteAdd' data-action='insert'><i class='fa fa-plus'></i></span>";
        $append .= "<span class = 'btn input-group-addon _setModalClienteEdit' data-action='edit'><i class='fa fa-pencil'></i></span>";
        $this->addElement(array(
            'type' => 'select',
            'name' => 'customer_id',
            'label'=>'Cliente',
            'multiOptions'=>$this->getListCustomers(),
            'append'=>$append,
            'required'=>true
        ));  
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'event_type_id',
            'label'=>'Evento',
            'multiOptions'=>$this->getListTypeEvents(),
            'required'=>true
        ));  
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'status',
            'label'=>'Status',
            'multiOptions' => $this->getListStatus(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary m-t-1 m-b-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
            'onclick'=>"document.location = '".ROOT_HOST."/Controller/Appointment.php'"),
            'class'=>'btn btn-danger m-t-1 m-b-1'
        ));

    }
    
    public function getListStatus(){
        $repository = new AppointmentRepository();
        $list = $repository->getListStatus();
         
        $array = array();
        foreach($list as $key => $value){
            $array[$key] = $value;
        }
        return $array;        
    }
    
    public function getListCustomers(){
        $repository = new ClienteRepository();
        $result = $repository->getListaSelectClientes();

         $array = array('' => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
     public function getListTypeEvents(){
        $repository = new AppointmentRepository();
        $result = $repository->getTypeEvents();

         $array = array('' => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
    public function populate($data){
        $tools = new Tools();       
        if(isset($data['appointment_date']) && $tools->isValidaDateYYYMMDD($data['appointment_date'])){
            $data['appointment_date'] = $tools->setFormatDateToForm($data['appointment_date']);
        }
        
        parent::populate($data);
    }
    
    public function isValid() {
        $valid = parent::isValid();        
        $flashmessenger = new FlashMessenger();                
         
        return $valid;
    }
}