<?php
/**
 * Description of NivelForm
 *
 * @author carlos
 */

class AppointmentOptionsForm extends Form {

    public function __construct() {
        $this->setActionForm('AppointmentOptions.php');
        $this->setClass('appointmentoptions form-horizontal');
        $this->setMethod('post');
        parent::__construct();
        $this->init();
    }

    public function init() {
        $this->addElement(array(
            'type' => 'select',
            'name' => 'day',
            'label'=>'Dia',
            'multiOptions'=>array(
                '1'=>'Lunes',
                '2'=>'Martes',
                '3'=>'Miercoles',
                '4'=>'Jueves',
                '5'=>'Viernes',
                '6'=>'Sabado',
                '7'=>'Domingo',),
            'required'=> true
        ));
        
       $this->addElement(array(
            'type' => 'select multiple',
            'name' => 'hours',
            'label'=>'Horas',
            'multiOptions'=>array(
                '08:00'=>'8:00',
                '09:00'=>'9:00',
                '10:00'=>'10:00',
                '11:00'=>'11:00',
                '12:00'=>'12:00',
                '13:00'=>'13:00',
                '14:00'=>'14:00',
                '15:00'=>'15:00',
                '16:00'=>'16:00',
                '17:00'=>'17:00',
                '18:00'=>'18:00',
                '19:00'=>'19:00',
                '20:00'=>'20:00',),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary m-t-1 m-b-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
            'onclick'=>"document.location = '".ROOT_HOST."/Controller/AppointmentOptions.php'"),
            'class'=>'btn btn-danger m-t-1 m-b-1'
        ));
    }
    
    public function populate($data){
        if(isset($data['hours']) && $data['hours']!=null && is_array($data['hours'])){
            $sucursales = array();
            foreach($data['hours'] as $sucursal){
                $sucursales[$sucursal] = $sucursal;
            }
            $data['hours'] = $sucursales;
        }
        parent::populate($data);
    }
    
    public function isValid() {
        $valid = parent::isValid();                
        
        $appointmentOptions = new AppointmentOptionsRepository();
        if($appointmentOptions->_existDay($this->getValueElement('day'),$this->getId())){
            $flashmessenger = new FlashMessenger();
            $flashmessenger->addMessage(array('danger'=>'Ya existe opciones de citas para este dia.'));
            return null;
        }
        
        return $valid;
    }
}