<?php
/**
 * Description of NivelForm
 *
 * @author carlos
 */

class PreorderForm extends Form {

    public function __construct() {
        $this->setActionForm('Preorder.php');
        $this->setName('preorder');
        $this->setClass('preorder form-horizontal');
        $this->setMethod('post');
        $this->setDefaultFormElementsColSize(7);
        $this->setDefaultFormLabelsColSize(4);
        parent::__construct();
        $this->init();
    }

    public function init() {
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'preorder_num'
        ));
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'create_special_order'
        ));
    
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'sales_person_id'
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'delivery_date',
            'label'=>'Fecha de evento',
            'required'=> true
        ));
        
        $append = "<span class = 'btn input-group-addon _setModalClienteAdd' data-action='insert'><i class='fa fa-plus'></i></span>";
        $append .= "<span class = 'btn input-group-addon _setModalClienteEdit' data-action='edit'><i class='fa fa-pencil'></i></span>";
        $this->addElement(array(
            'type' => 'select',
            'name' => 'customer_id',
            'label'=>'Cliente',
            'multiOptions'=>$this->getListCustomers(),
            'append'=>$append,
            'required'=>true
        ));  
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'event_type_id',
            'label'=>'Evento',
            'multiOptions'=>$this->getListTypeEvents(),
            'required'=>true
        ));  
        
         $this->addElement(array(
            'type' => 'text',
            'name' => 'estimated_price',
            'label'=>'Precio',
            'validators'=>array('double'),
            'required'=> true
        ));        
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'status',
            'label'=>'Status',
            'multiOptions' => $this->getListStatus(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'reason_reject',
            'label'=>'Razon de rechazo',
            'multiOptions' => $this->getListReasonReject(),
            'required'=> false
        ));
        
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'comments_customer',
            'label'=>'Descripcion pedido',
            'optionals'=>array('style'=>'width:530px'),
            'required'=>false
        ));     
         
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'comments_sales_person',
            'label'=>'Descripcion preorden',
            'optionals'=>array('style'=>'width:530px'),
            'required'=>false
        ));    
        
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'comments_reject',
            'label'=>'Descripcion de rechazo',
            'required'=>false
        ));    
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'class'=>'btn btn-primary m-t-1 m-b-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
            'onclick'=>"document.location = '".ROOT_HOST."/Controller/Preorder.php'"),
            'class'=>'btn btn-danger m-t-1 m-b-1'
        ));

    }
    
    public function getListStatus(){
        $repository = new PreorderRepository();
        $list = $repository->getListStatus();
         
        $array = array();
        foreach($list as $key => $value){
            $array[$key] = $value;
        }
        return $array;        
    }
    
    public function getListCustomers(){
        $repository = new ClienteRepository();
        $result = $repository->getListaSelectClientes();

         $array = array('' => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
    public function getListTypeEvents(){
        $repository = new PreorderRepository();
        $result = $repository->getTypeEvents();

         $array = array('' => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
    public function getListReasonReject(){
        $repository = new PreorderRepository();
        $result = $repository->getReasonsReject();

         $array = array('' => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
        }
         return $array;
    }
    
    public function populate($data){
        $tools = new Tools();               
        if(isset($data['delivery_date']) && substr_count($data['delivery_date'], '-') > 0){
           $data['delivery_date'] = $tools->setFormatDateTimeToForm($data['delivery_date']);
        }
        
        if($data['status'] == '3'){
            $this->setAsRequired(array('reason_reject'));
        }else{
            $this->noRequired(array('reason_reject'));
        }
        
        parent::populate($data);
    }
    
    public function isValid() {
        $valid = parent::isValid();                     
         
        return $valid;
    }
}