<?php
/**
 * Description of NivelForm
 *
 * @author carlos
 */

class PromotionForm extends Form {

    public function __construct() {
        $this->setActionForm('Promotion.php');
        $this->setName('promotion');
        $this->setClass('promotion form-horizontal');
        $this->setMethod('post');
        parent::__construct();
        $this->init();
    }

    public function init() {
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'promotion_num'
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'tipo',
            'label'=>'Tipo',
            'multiOptions'=>array('descuento'=>'Descuento'),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'name',
            'label'=>'Nombre',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'code',
            'label'=>'Codigo',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'percentage',
            'label'=>'Porcentaje',
            'class'=>'mg_decimal',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'start_date',
            'label'=>'Inicia',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'start_date',
            'label'=>'Inicia',
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'end_date',
            'label'=>'Termina',
            'required'=> true
        ));                   
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'status',
            'label'=>'Status',
            'multiOptions' => $this->getListStatus(),
            'required'=> true
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary m-t-1 m-b-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
            'onclick'=>"document.location = '".ROOT_HOST."/Controller/Promotion.php'"),
            'class'=>'btn btn-danger m-t-1 m-b-1'
        ));

    }
    
    public function getListStatus(){
        $repository = new PromotionRepository();
        $list = $repository->getListStatus();
         
        $array = array();
        foreach($list as $key => $value){
            $array[$key] = $value;
        }
        return $array;        
    }
    
    public function getListCustomers(){
        $repository = new ClienteRepository();
        $result = $repository->getListaSelectClientes();

         $array = array('' => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
     public function getListTypeEvents(){
        $repository = new PromotionRepository();
        $result = $repository->getTypeEvents();

         $array = array('' => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
    public function populate($data){
        $tools = new Tools();            
        
        if(isset($data['start_date']) && substr_count($data['start_date'], '-') > 0){           
           $data['start_date'] = $tools->setFormatDateTimeToForm($data['start_date']);
        }
        
        if(isset($data['end_date']) && substr_count($data['end_date'], '-') > 0){           
           $data['end_date'] = $tools->setFormatDateTimeToForm($data['end_date']);
        }
        
        parent::populate($data);
    }
    
    public function isValid() {
        $valid = parent::isValid();        
        $flashmessenger = new FlashMessenger();                
         
        return $valid;
    }
}