<?php
class PurchaseForm extends Form {    
    public function __construct() {
        $this->setName('Purchase');
        $this->setActionForm('Purchase.php');
        $this->setEnctype('multipart/form-data');
        $this->setMethod('post');
        $this->setDefaultFormLabelsColSize(4);
        $this->setDefaultFormElementsColSize(8);
        parent::__construct();
        $this->init();
    }

    public function init() {      
        $attributes_wrapper_append_select = array('class'=>'select2-bootstrap-append');        
        $attributes_wrapper_append_date = array('id'=>'dateDatePicker');
        
        /*Importe sin descuentos*/
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'subtotal',
            'required'=>false,
            'validators'=>array('double')
        ));     
         
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'total',
            'required'=>false,
            'validators'=>array('double')
        ));        
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'descuento_items',
            'required'=>false,
            'validators'=>array('double')
        ));    
         
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'status',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'userName',
        ));        
         
          $this->addElement(array(
            'type' => 'hidden',
            'name' => 'formatedCreadoFecha',
        ));        
        
        $append = "<span class = 'btn input-group-addon'><i class='fa fa-calendar'></i></span>";
        $this->addElement(array(
            'type' => 'text',
            'name' => 'date',
            'label'=>'Fecha',
            'validators'=>array('date'),
            'required'=>true,
            'value'=>date('m/d/Y'),
            'append'=>$append,
            'wrapper_attributes'=>$attributes_wrapper_append_date
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'requested_by',
            'label'=>'Requerido por',
            'required'=>true
        ));
       
        $this->addElement(array(
            'type' => 'text',
            'name' => 'approved_by',
            'label'=>'Aprobado por',
            'required'=>true
        ));

        $this->addElement(array(
            'type' => 'select',
            'name' => 'id_vendor',
            'label'=>'Proveedor',
            'multiOptions'=>$this->listVendor(),
            'required'=>true,
            'class'=>'selectProveedor', // Clase para selecto cuando se agrega un nuevo proveedor y se recarga lista.
        ));  
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'reference',
            'label'=>'Num. Factura',
            'required'=>true
        ));               
                
        $this->addElement(array(
            'type' => 'text',
            'name' => 'lot',
            'label'=>'Lote',
            'required'=>false
        ));          
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'payment_terms_id',
            'label'=>'Terminos',
             'multiOptions'=>$this->getListPaymentTerms(),
            'required'=>true,
        )); 
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'due_date',
            'label'=>'Fecha de pago',
            'optionals'=>array('readOnly'=>true),
            'required'=>true,
        )); 
        
       $this->addElement(array(
            'type' => 'select',
            'name' => 'discount_general_type',
            'multiOptions'=>array('amount'=>'Descuento por monto','percent'=>'Descuento por porcentaje'),
            'class'=>'form-control',
        )); 
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'discount_general',
            'value'=>'0',
            'class'=>'text-right form-control _maskDouble',
            'optionals'=>array('style'=>'width:70px;padding:5px')
        )); 
        
        $this->addElement(array(
            'type' => 'file',
            'name' => "invoice_file",
            'label' => 'Factura de compra',
            'class' => 'upload',
            'required' => false,
            'optionals' => array(
                'title' => 'Factura de compra'
            ),
        ));
        
         $this->addElement(array(
            'type' => 'file',
            'name' => "credit_note_file",
            'label' => 'Nota de credito',
            'class' => 'upload',
            'required' => false,
            'optionals' => array(
                'title' => 'Nota de credito'
            ),
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'credit_note',
            'label'=>'Num. Nota de credito',
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'credit_note_amount',
            //'label'=>'NC monto',
            'required'=>false,
            'class'=>'text-right'
        ));
        
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'comments',
            'label'=>'Notas',
            'required'=>false
        ));          
        
        $this->addElement(array(
            'type'=>'button',
            'name'=>'agregar_producto',
            'value'=>$this->_getTranslation('Agregar producto'),
            'class'=>"btn btn-default",
        )); 
        
        $this->addElement(array(
            'type'=>'button',
            'name'=>'terminar',
            'value'=>$this->_getTranslation('Terminar'),
            'class'=>'btn btn-primary',
            'optionals'=>array("onClick"=>"submit('Purchase')")
        ));        
    }
    
    public function listUser(){
        $repository = new UsuarioRepository();
        $result = $repository->getListaSelectUsuarios();        
        
        $array = array(''=>'Seleccionar una opcion...');        
        if ($result) {               
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }           
        }
        return $array;
    }
    
    public function listVendor(){
        $repository = new VendorRepository();
        $result = $repository->getListSelectVendors();
        
        $array = array('' => 'Seleccionar una opcion...');
        if ($result) {            
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }           
        }
         return $array;
    }
    
    public function getListPaymentTerms(){
        $repository = new PaymentTermsRepository();
        $result = $repository->getListSelectPaymentTerms();        
        
        $array = array('' => 'Seleccionar una opcion...');
        if ($result) {               
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }           
        }
        return $array;
    }    
    
    public function listaImpuestos(){            
        $repository = new GoodAndServiceCatalogRepository();
        $result = $repository->getListaSelectImpuestos();
        
        $array = array();
        if ($result) {            
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }       
    
    public function populate($data) { 
        $tools = new Tools();
        if(isset($data['date']) && $tools->isValidaDateYYYMMDD($data['date'])){
            $data['date'] = $tools->setFormatDateToForm($data['date']);
        }
        
        if(isset($data['due_date']) && $tools->isValidaDateYYYMMDD($data['due_date'])){
            $data['due_date'] = $tools->setFormatDateToForm($data['due_date']);
        }                  
        
        parent::populate($data);
    } 
    
    public function isValid() {        
        $valid = parent::isValid();         
        return $valid;
    }
}