<?php
class StoreStockTemplateForm extends Form {    
    public function __construct() {
        $this->setName('storestocktemplate');
        $this->setActionForm('StoreStockTemplate.php');
        $this->setClass('storestocktemplate');
        $this->setMethod('post');
        $this->setDefaultFormElementsColSize('8');
        $this->setDefaultFormLabelsColSize('4');
        parent::__construct();
        $this->init();
    }

    public function init() {             
       $this->addElement(array(
            'type' => 'text',
            'name' => 'template_name',
            'label'=>'Nombre',
            'required'=> true
        ));        
      
        $this->addElement(array(
            'type' => 'select',
            'name' => 'status',
            'label'=>'Status',
            'multiOptions'=>array('1'=>'Activo','2'=>'Inactivo'),
            'required'=>true
        ));
                 
         /*Se utiliza para consulta si existe en la tabla de requisitions_details_X, si existe se actualiza registro.*/
         $this->addElement(array(
            'type' => 'hidden',
            'name' => 'idDetailTemp',
            'required'=>false
        )); 
         
         $append = "<span class = 'btn input-group-addon' data-toggle='modal' data-target='#modalAgregarProducto'><i class='fa fa-plus'></i></span>";
         $this->addElement(array(
            'type' => 'select',
            'name' => 'product',
            'label'=>'Producto',
            'multiOptions'=>$this->getListProducts(),
            'col-size-label'=>'12',
            'col-size-element'=>'12',
            'append'=>$append

         ));
        
        $this->addElement(array(
            'type' => 'select multiple',
            'name' => 'days',
            'label'=>'Dias',
            'multiOptions'=>$this->getListDays(),
            'required'=>false,
            'col-size-element'=>'12'
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'min',
            'label'=>'Minimo',
            'required'=>false,
            'col-size-element'=>'12'
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'max',
            'label'=>'Maximo',
            'required'=>false,
            'col-size-element'=>'12'
        ));
        
        $this->addElement(array(
            'type'=>'button',
            'name'=>'buscar',
            'value'=>$this->_getTranslation('Agregar'),
            'class'=>'btn btn-success',
            'optionals'=>array('onClick'=>'setStoreStockTemplateDetails()')
        ));
        
        $this->addElement(array(
            'type'=>'button',
            'name'=>'terminar',
            'value'=>$this->_getTranslation('Terminar'),
            'class'=>'btn btn-primary',
            'optionals'=>array("onClick"=>"submit('storestocktemplate')")
        ));        
    }
    
    public function getListProducts(){
        $repository = new ProductoRepository();
        #1 = status activo
        $productos = $repository->getListaProductos('producto');
        
        $array = array('0'=>'Seleccionar una opcion..');        
        foreach($productos as $producto){      
            $array[$producto['id']] = $producto['codigo']." - ".$producto['descripcion']." ".$producto['tamano'];
        }
        
        $list= array();
        foreach ($array as $key => $value) {
            $list[$key] = $value;
        }
        return $list;
    }
    
    public function getListDays(){
        $repository = new StoreRepository();
        $result = $repository->getListDays();
        
        $array = array(''=>'Seleccionar una opcion...');
        if ($result) {
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
    public function getListColonias($codigoPostal){
        $repository = new EmpresaRepository();
        $result = $repository->getListSelectColonias($codigoPostal);
        
        $array = array('' => 'Seleccionar una opcion...');
        if ($result) {
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }

    

    
    public function populate($data){     
        parent::populate($data);
    }
}