<?php
class SupplieAndServiceForm extends Form {
    
    public function __construct() {
        $this->setActionForm('SupplieAndService.php');
        $this->setName('supplieandservice');
        $this->setMethod('post');
        $this->setDefaultFormLabelsColSize(5);
        $this->setDefaultFormElementsColSize(7);
        parent::__construct();
        $this->init();
    }

    public function init() {            
        $this->addElement(array(
            'type' => 'select',
            'name' => 'type',
            'label'=>'Tipo',
            'multiOptions'=>array(''=>'Seleccionar una opcion...','bienesyservicios'=>'Bienes y/o servicios','insumo'=>'Producto'),
            'required'=>true
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'code',
            'label'=>'Codigo',
            //'value'=>$this->getNextIdProduct(),
            'required'=>false
        ));

        $this->addElement(array(
            'type' => 'text',
            'name' => 'description',
            'label'=>'Descripcion',
            'required'=>true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'category_id',
            'label'=>'Categoria',
            'multiOptions'=>$this->getListCategories(),
        ));       
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'brand_id',
            'label'=>'Marca',
            'multiOptions'=>$this->listaMarcas(),            
            'required'=>false
        ));         
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'presentation_id',
            'label'=>'Presentacion',
            'multiOptions'=>$this->listaPresentaciones(), 
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'um_id',
            'label'=>'Unidad de medida',
            'multiOptions'=>$this->listaUnidadesMedida(), 
            'required'=>false
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'cost',
            'label'=>'Precio compra',
            'validators'=>array('double'),
            'required'=>false,
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'taxes',
            'label'=>'Impuestos',
            'multiOptions'=>$this->listaImpuestos(),
        ));      
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'taxes_included',
            'label'=>'Impuestos incluidos',
            'multiOptions'=>array('1'=>'Si','0'=>'No'), 
            'value'=>'1',
            'required'=>true
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'llevar_inventario',
            'label'=>'Llevar inventario',
            'multiOptions'=>array('Si'=>'Si','No'=>'No'),
            'value'=>'Si',
            'required'=>true
        ));
        
         $this->addElement(array(
            'type' => 'text',
            'name' => 'min_stock',
            'label'=>'Stock minimo',
            'validators'=>array('double'),
            'required'=>false,
        ));
         
        $this->addElement(array(
            'type' => 'text',
            'name' => 'ledger_account',
            'label'=>'Cuenta contable',
            'required'=>false,
        ));
         
        $this->addElement(array(
            'type' => 'select',
            'name' => 'status',
            'label'=>'Status',
            'multiOptions'=>array('1'=>'Activo','2'=>'Inactivo'),
            'required'=>true
        ));
        
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'comments',
            'label'=>'Comentarios',
        ));       
        
         $this->addElement(array(
            'type' => 'button',
            'name' => 'send',
            'value'=> $this->_getTranslation('Terminar'),
            'optionals'=>array(
                'onclick'=>"submit()"),
            'class'=>'btn btn-primary m-t-1 m-b-1'
        ));
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancel',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
                'onclick'=>"document.location = '".ROOT_HOST."/Controller/SupplieAndService.php'"),
            'class'=>'btn btn-danger m-t-1 m-b-1'
        ));
    }
    
    public function getListStatus(){
        $repository = new SupplieAndServiceRepository();
        $list = $repository->getListStatus();
         
        $array = array();
        if($list){
            foreach($list as $key => $value){
                $array[$key] = $value;
            }
        }       
        return $array;            
    }      
    
    public function listaMarcas(){
        $repository = new MarcaRepository();
        $result = $repository->getListaSelectMarcas();
        
         $array = array(0 => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }            
        }
        return $array;
    }   
    
    public function listaImpuestos(){            
        $repository = new SupplieAndServiceRepository();
        $result = $repository->getListaSelectImpuestos();
        
        if ($result) {            
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }            
        }
        return $array;
    }     
    
    public function getListCategories(){
        $repository = new CategoriaEntity();
        $list = $repository->getListaSelectCategorias('Insumo');
        
        $array = array('0'=>'Seleccionar una opcion...');
        if ($list) {            
            foreach ($list as $key => $value) {
                $array[$key] = $value;
            }           
        }
        return $array;
    }
    
     public function listaPresentaciones(){
        $repository = new PresentacionRepository();
        $result = $repository->getListaSelectPresentaciones();
        
         $array = array(0 => 'Seleccionar una opcion...');
        if ($result) {           
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }           
        }
        return $array;
    }   
    
    public function listaUnidadesMedida(){
        $repository = new UnidadMedidaRepository();
        $result = $repository->getListaSelectUnidadesMedida();
        
        $array = array(0 => 'Seleccionar una opcion...');
        if ($result) {            
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }            
        }
        return $array;
    }    
    
    public function isValid() {
        $valid = parent::isValid();        
        $flashmessenger = new FlashMessenger();                
        
        $idProducto = $this->getId();
        $codigo = $this->getElement('code');
        
        $repository = new SupplieAndServiceRepository();
        $producto = $repository->existeCodigo($codigo['value'],$idProducto);
        if($producto !== null){
            $message  = $this->_getTranslation('Ya se esta utilizando este codigo para el producto: ');
            $message .= $producto['description'];
            $flashmessenger->addMessage(array('danger'=>$message));
            return null;
        }  
         
        return $valid;
    }
    
    public function populate($data){        
        parent::populate($data);
    }
}