<?php
class SupplieReturnForm extends Form {    
    public function __construct() {
        $this->setName('suppliereturn');
        $this->setActionForm('SupplieReturn.php');
        $this->setClass('return form-horizontal');
        $this->setMethod('post');
        parent::__construct();
        $this->init();
    }

    public function init() {                        
        $attributes_wrapper_append_date = array('id'=>'dateDatePicker');
        $append = "<span class = 'btn input-group-addon'><i class='fa fa-calendar'></i></span>";
        $this->addElement(array(
            'type' => 'text',
            'name' => 'date',
            'label'=>'Fecha',
            'validators'=>array('date'),
            'required'=>true,
            'append'=>$append,
            'wrapper_attributes'=>$attributes_wrapper_append_date,
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'returned_by',
            'label'=>'Retornado por',
            'required'=>true
        ));
        
        $this->addElement(array(
            'type' => 'textarea',
            'name' => 'comments',
            'label'=>'Notas',
            'required'=>false
        ));          
        
         /*Se utiliza para consulta si existe en la tabla de store_out_details_X, si existe se actualiza registro.*/
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'idProduct',
        ));
        
        $this->addElement(array(
            'type' => 'hidden',
            'name' => 'idDetailTemp',
        ));
          
        $append = "<span class = 'btn input-group-addon' data-toggle='modal' data-target='#modalAgregarProducto'><i class='fa fa-plus'></i></span>";
        $this->addElement(array(
            'type' => 'text',
            'name' => 'product',
            'label'=>'Producto',
            'optionals'=>array('onKeyPress'=>'onEnterReturn(event.keyCode,this)','placeholder'=>'Teclea o escanea producto para el envio'),
            'col-size-element'=>'12',
            'append'=>$append
        ));
        
        $this->addElement(array(
            'type' => 'text',
            'name' => 'quantity',
            'label'=>'Cantidad',
            'value'=>'1',
            'required'=>false,
            'col-size-element'=>'12'
        ));
        
        $this->addElement(array(
            'type' => 'select',
            'name' => 'location',
            'label'=>'Locacion',
            'col-size-element'=>'12'
         ));
        
        $this->addElement(array(
            'type'=>'button',
            'name'=>'add',
            'value'=>$this->_getTranslation('Agregar'),
            'class'=>'btn btn-default',
            'optionals'=>array('onClick'=>'setReturnDetails()')
        ));
        
        $this->addElement(array(
            'type'=>'button',
            'name'=>'close',
            'value'=>$this->_getTranslation('Cerrar'),
            'class'=>'btn btn-default',
            'optionals'=>array(
                'data-dismiss'=>'modal',
                'aria-label'=>'Close'
            )
        ));
        
        $this->addElement(array(
            'type'=>'button',
            'name'=>'terminar',
            'value'=>$this->_getTranslation('Terminar'),
            'class'=>'btn btn-primary',
            'optionals'=>array("onClick"=>"submit('suppliereturn')")
        ));   
        
        $this->addElement(array(
            'type' => 'button',
            'name' => 'cancelar',
            'value'=> $this->_getTranslation('Cancelar'),
            'optionals'=>array(
                'onclick'=>"document.location = '".ROOT_HOST."/Controller/SupplieReturn.php'"),
            'class'=>'btn btn-danger'
        ));
    }
    
    public function listVendor(){
        $repository = new VendorRepository();
        $result = $repository->getListSelectVendors();
        
        if ($result) {
            $array = array('0' => '');
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    }
    
    public function getListLocations(){
        $repository = new StoreInRepository();
        $result = $repository->getListSelectLocations();
        
        $array = array('0' => '');
        if ($result) {            
            foreach ($result as $key => $value) {
                $array[$key] = $value;
            }
            return $array;
        }
    } 
    
    public function populate($data) { 
        $tools = new Tools();
        if(isset($data['date']) && $tools->isValidaDateYYYMMDD($data['date'])){
            $data['date'] = $tools->setFormatDateToForm($data['date']);
        }
        parent::populate($data);
    } 
}