<?php 
    $arrayData = $data['data'];
    $colTitulosTemp = $arrayData[0];
    
    $fieldsToPrint = array(
        'compra'=>$this->_getTranslation('Compra'),
        'referencia'=>$this->_getTranslation('Referencia'),
        'fecha'=>$this->_getTranslation('Fecha'),
        'fecha_pago'=>$this->_getTranslation('Fecha de pago'),
        'importe'=>$this->_getTranslation('Importe'),
        'pagos_abonos'=>$this->_getTranslation('Pagos y abonos'),
        'nota_credito'=>$this->_getTranslation('Nota de credito'),
        ''=>'',
        'saldo'=>$this->_getTranslation('Saldo'),       
    );
    
    foreach($fieldsToPrint as $titulo => $value){
        if(key_exists($titulo, $fieldsToPrint)){            
            $colTitulos[] = $fieldsToPrint[$titulo];
        }
    }
    
    $objPHPExcel = new PHPExcel();
    $objPHPExcel->getActiveSheet()->freezePane('A3');
    $col = count($colTitulos);
    $lastCol = $this->getColLetter($col-1);
    
    $objPHPExcel->getActiveSheet()->mergeCells("A1:".$lastCol."1");            
    $objPHPExcel->getActiveSheet()->getRowDimension('1')->setRowHeight(50);
    $objPHPExcel->getActiveSheet()->getStyle("A1")->getFont()->setBold(true);
    $objPHPExcel->getActiveSheet()->setCellValue("A1", $this->headerExcelReport);
    $objPHPExcel->getActiveSheet()->getStyle('A1')->getAlignment()->setWrapText(true);
    $objPHPExcel->getActiveSheet()->getStyle("A1")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
    $objPHPExcel->getActiveSheet()->getStyle("A1")->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);
    
    $objPHPExcel->getActiveSheet()->getStyle("A2:".$lastCol."2")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
    $objPHPExcel->getActiveSheet()->fromArray($colTitulos,NULL,'A2');   
    
    $row=3;
    $vendor = null;
    $vendorSaldoVencido = 0;
    $totalDeDocumentos = 0;
    foreach ($arrayData as $key => $data) {
        $i=0;        
        
        #e imprmimen totales de cada proveedor
        if($vendor!=null){
            if($data['vendor_id'] != $vendor){
                $objPHPExcel->getActiveSheet()->setCellValue("F$vendorSubtitulo",$totalDeDocumentos);
                $objPHPExcel->getActiveSheet()->getStyle("F$vendorSubtitulo")->getFont()->setBold(true);
                
                $vendorFin = $row - 1;
                $objPHPExcel->getActiveSheet()->setCellValue("H$row", 'Saldo total');
                $objPHPExcel->getActiveSheet()->setCellValue("I$row", "=SUM(I$vendorInicio:I$vendorFin)");
                $objPHPExcel->getActiveSheet()->getStyle("I$row")->getNumberFormat()->setFormatCode('$#,##0.00_ ;[Red]-$#,##0.00');
                $row++;
                
                $objPHPExcel->getActiveSheet()->setCellValue("H$row", 'Saldo vencido');
                $objPHPExcel->getActiveSheet()->setCellValue("I$row", $vendorSaldoVencido);
                $objPHPExcel->getActiveSheet()->getStyle("I$row")->getNumberFormat()->setFormatCode('$#,##0.00_ ;[Red]-$#,##0.00');
                $objPHPExcel->getActiveSheet()->getStyle("H$row:I$row")->getFont()->setBold(true);
                $row++;
                
                $vendorSaldoVencido = 0;
                $totalDeDocumentos = 0;
            }
        } 
            
        #Se imprimirn encabezados de cada proveedor
        if($data['vendor_id'] != $vendor){    
            $vendorSubtitulo = $row;
            $objPHPExcel->getActiveSheet()->mergeCells("A$row:D$row");            
            $objPHPExcel->getActiveSheet()->getRowDimension('1')->setRowHeight(50);
            $objPHPExcel->getActiveSheet()->getStyle("A$row")->getFont()->setBold(true);
            $objPHPExcel->getActiveSheet()->setCellValue("A$row", $data['proveedor']);
            
            $objPHPExcel->getActiveSheet()->getStyle("E$row")->getFont()->setBold(true);
            $objPHPExcel->getActiveSheet()->setCellValue("E$row", 'Total de documentos');
            $row++;
            
            $vendor = $data['vendor_id'];
            $vendorInicio = $row;                     
        }
        
        #Suma documentos de cada proveedor
        #Suma de monto vencido de cada proveedor
        $totalDeDocumentos++;
        if($data['vencido'] == '1'){$vendorSaldoVencido += $data['saldo'];}
        
        foreach ($fieldsToPrint as $field => $value) {             
            if(key_exists($field, $data)){ 
                $col = $this->getColLetter($i);
                if($col == 'H'){
                    #Imprimimos celda vacia en columna H
                    $objPHPExcel->getActiveSheet()->setCellValue($col . $row, '');
                    $i++;
                    $col = $this->getColLetter($i);
                }
                
                $objPHPExcel->getActiveSheet()->setCellValue($col . $row, $data[$field]);               
                $i++;
            }      

            $objPHPExcel->getActiveSheet()->getStyle("A$row:D$row")->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
            $objPHPExcel->getActiveSheet()->getStyle("E$row:G$row")->getNumberFormat()->setFormatCode('$#,##0.00_ ;[Red]-$#,##0.00');
            $objPHPExcel->getActiveSheet()->getStyle("I$row")->getNumberFormat()->setFormatCode('$#,##0.00_ ;[Red]-$#,##0.00');
            
            #Si compra esta vencida marcamos con background
            if($data['vencido'] == 1){
                $objPHPExcel->getActiveSheet()->getStyle("A".$row.":I".$row)->getFill()->setFillType(PHPExcel_Style_Fill::FILL_SOLID);
                $objPHPExcel->getActiveSheet()->getStyle("A".$row.":I".$row)->getFill()->getStartColor()->setARGB('F6F6F6');      
            }            
        }
        $row++;
    }
    
    #Imprimir totales de ultimo proveedor
    $objPHPExcel->getActiveSheet()->setCellValue("F$vendorSubtitulo",$totalDeDocumentos);
    $objPHPExcel->getActiveSheet()->getStyle("F$vendorSubtitulo")->getFont()->setBold(true);

    $vendorFin = $row - 1;
    $objPHPExcel->getActiveSheet()->setCellValue("H$row", 'Saldo total');
    $objPHPExcel->getActiveSheet()->setCellValue("I$row", "=SUM(I$vendorInicio:I$vendorFin)");
    $objPHPExcel->getActiveSheet()->getStyle("I$row")->getNumberFormat()->setFormatCode('$#,##0.00_ ;[Red]-$#,##0.00');
    $row++;

    $objPHPExcel->getActiveSheet()->setCellValue("H$row", 'Saldo vencido');
    $objPHPExcel->getActiveSheet()->setCellValue("I$row", $vendorSaldoVencido);
    $objPHPExcel->getActiveSheet()->getStyle("I$row")->getNumberFormat()->setFormatCode('$#,##0.00_ ;[Red]-$#,##0.00');
    $objPHPExcel->getActiveSheet()->getStyle("H$row:I$row")->getFont()->setBold(true);

    foreach(range('A',$lastCol) as $columnID) {
        $objPHPExcel->getActiveSheet()->getColumnDimension($columnID)
            ->setAutoSize(true);
    }

    $objPHPExcel->setActiveSheetIndex(0);   
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
    
    if($this->saveFile == true){
        $objWriter->save($this->getTempFolder()."/".$this->getNombreArchivo().".xlsx");
    }else{                
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header("Content-Disposition: attachment;filename=".$this->getNombreArchivo().".xlsx");
        header('Cache-Control: max-age=0');
        $objWriter->save('php://output');
        exit;
    }
    unset($objWriter);