<?php   
        $formasPago = $data['data_cobros'];       
        $ventas = $data['data_ventas'];                        
        
        $pdf = new PDF();
        $pdf->AddPage('P','');
        
        $empresaRepo = new CompanyRepository();
        $empresaData = $empresaRepo->getById(1);
        
        $sucursalNameString = '';
        $storeRepo = new StoreRepository();
        $storesName = $storeRepo->getListSelectStores();
        
        $options = $this->getOptions();        
        if(!empty($options['store_id'])){
            if(is_array($options['store_id'])){
                foreach($options['store_id'] as $key => $value){
                    $sucursalNameString .= $storesName[$value].' - ';
                }
            }else{
                $sucursalNameString .= $storesName[$options['store_id']];
            }
        }
        
        $login = new Login();
        
        $pdf->SetFont('Arial','B','10');     
        $pdf->Cell(190, 12,  $this->headerExcelReport, '0', 1, 'C'); //<== margin left   
        $pdf->Cell(190, 4, trim($sucursalNameString,'- '), '0', 1, 'C'); //<== margin left      
        
        $pdf->ln(5);
        $pdf->SetFont('Arial','','10');
        $pdf->cell(50,5,'','',0);/*margin*/
        $pdf->cell(45,5,' Net Sales','0',0);
        $pdf->cell(45,5,'$'.number_format($ventas['importe'],2),'0',1,'R');        
        
        $pdf->cell(50,5,'','',0);
        $pdf->cell(45,5,'- Discounts','0',0);
        $pdf->cell(45,5,'$'.number_format($ventas['descuentos'],2),'0',1,'R');        
        
        $pdf->cell(50,5,'','',0);
        $pdf->cell(45,5,'= Subtotal','0',0);
        $pdf->cell(45,5,'$'.number_format($ventas['subtotal'],2),'0',1,'R');      
        
        $pdf->cell(50,5,'','',0);
        $pdf->cell(45,5,'+ Taxes','0',0);
        $pdf->cell(45,5,'$'.number_format($ventas['impuestos'],2),'0',1,'R');        
        
        $pdf->cell(50,5,'','',0);
        $pdf->cell(45,5,'= Total Sales','T',0);
        $pdf->cell(45,5,'$'.number_format($ventas['total_venta'],2),'T',1,'R');     
        
        
        $pdf->ln(5);
        $pdf->SetFont('Arial','B','10');
        $pdf->cell(50,5,'','',0);/*margin*/
        $pdf->cell(45,5,'Sales by payment method','0',1);
        
        $translationPaymentMethod = array("Efectivo"=>'Cash','Tarjeta de credito'=>'Credit card','Tarjeta de debito'=>'Debit card','Cheque'=>'Check','EBT'=>'EBT');        
        $totalPaymentSales = 0;
        $totalCardFee = 0;
        $pdf->SetFont('Arial','','10');
        foreach($formasPago as $payment){
            $paymentMethodName = $payment['forma_pago'];
            if(key_exists($payment['forma_pago'], $translationPaymentMethod)){$paymentMethodName = $translationPaymentMethod[$payment['forma_pago']];}
        
            $totalPaymentSales += (float)$payment['total_cobro'];
            $totalCardFee += (float)$payment['comision_tarjeta'];
            $pdf->cell(50,5,'','',0);
            $pdf->cell(45,5,$paymentMethodName,'0',0);
            $pdf->cell(45,5,'$'.number_format($payment['total_cobro'],2),'0',1,'R');
        }        
        
        $pdf->cell(50,5,'','',0);
        $pdf->cell(45,5,'- Card fee','0',0);
        $pdf->cell(45,5,'$'.number_format($totalCardFee,2),'0',1,'R');      
        
        $pdf->cell(50,5,'','',0);
        $pdf->cell(45,5,'Total payments','T',0);
        $totalPayment = $totalPaymentSales - $totalCardFee;
        $pdf->cell(45,5,'$'.number_format($totalPayment,2),'T',1,'R');
        
        /*$pdf->ln(5);
        $diference = (float)$ventas['total_venta'] - $totalPayment;
        if($diference > 0){
            $pdf->cell(50,5,'','',0);
            $pdf->cell(45,5,'Faltante en cobros','0',0);
            $pdf->cell(45,5,'$'.number_format($diference,2),'0',1,'R');
        }elseif($diference < 0){
            $pdf->cell(50,5,'','',0);
            $pdf->cell(45,5,'Sobrante en cobros','0',0);
            $pdf->cell(45,5,'$'.number_format(abs($diference),2),'0',1,'R');
        } */     
      
        if($this->saveFile == true){    
            $pdf->Output($this->getTempFolder()."/".$this->getNombreArchivo().".pdf","F");
        }else{
            $pdf->Output();
        }
        
        
        
       

    

